
/*
tutorial_#5-01

=====================
Six Online Tutorials:
=====================

The tutorials online propose ideas and approaches, which allow the user to problematize and then practice to do something to use for their own purposes.
Describes the stages of construction of some systems to help the reader, step by step, to learn to do something, to build patchs be used effectively in the performance.
Examples are some ideas to change, expand, or start from scratch using the same ideas or the same solutions and then realize their control systems.

=====================
ONLINE TUTORIAL #5
5. "CLUSTER" (by E.Francioni) - example of live electronics based on timing.
=====================

In group tutorial_#5 will analyze some passages of the code of my CLUSTER (version for a percussionist, live electronics and sound support).
https://soundcloud.com/enrico_francioni/cluster-v-demo-2ch page has loaded a demo version of the composition to two channels.
CLUSTER in the instrument signal is variously processed.
In csd values are used "k", extracts from opcodes as timeinsts; the values are treated as a timeline directly in the orchestra; This methodology offers several advantages over the requests made by the score.

Exemplifying the cases contained in CLUSTER, in this group of tutorial_#5 signal of the solo instrument may (on time by the score - action time and duration):
     - Go through the microphone and returned output in real-time (non-processed or processed with FX);
     - Go through the microphone, be returned in output in real-time (non-processed or processed with FX) and simultaneously be captured (with opcodes delay or fout) and then returned (or recalled) Output (unprocessed or processed with FX ) after a delay time established.
    
The last two tutorials group tutorial_#5, are dedicated to spatial signal and controls in GUI required to "One-man performance".

***

In this tutorial_#5-01 signal the solo instrument passes through the microphone (on time by the score - action time and duration) to be returned in output in real-time.

Some observations:
     for orchestra
     - Listen to the original signal output

     in the Widgets Panel is given the opportunity to
     - Choose the type of input signal: "demo" (a fragment of CLUSTER) or "mic" (the microphone signal), before starting the algorithm;
     - Observe the timing of the timer.

*/

<CsoundSynthesizer>
<CsOptions>
</CsOptions>
<CsInstruments>

; header
sr		=	44100
ksmps		=	64
nchnls		=	1
0dbfs		=	1

;=================================================
	instr	1	; signal processing
;=================================================

ktinstr	timeinsts					; read absolute time in seconds
outvalue	"timer", ktinstr				; it exports the values of ktinstr, in the Display Widgets Panel

kin	invalue	"in"				; matter the value k (0/1)

if 		kin	== 0 then			; conditional step for the choice of the signal
aSIG		soundin	"demo.wav"		; audio demo
else
aSIG		inch	1				; microphone
endif

; timeline

; SILENCE
if 	(ktinstr	 >= 0) && (ktinstr < 3)	then
kgaincb	=	0				; in this way the signal does not pass

; SOUND
elseif	(ktinstr	 >= 3) && (ktinstr < 6)	then
kgaincb	=	1				; in this way the signal passes

; SILENCE
elseif 	(ktinstr	 >= 6) && (ktinstr <= 10) then
kgaincb	=	0				; in this way the signal does not pass

endif

out		aSIG*kgaincb				; output signal

endin


</CsInstruments>
<CsScore>
i1	0	10
e

</CsScore>
</CsoundSynthesizer><bsbPanel>
 <label>Widgets</label>
 <objectName/>
 <x>78</x>
 <y>271</y>
 <width>749</width>
 <height>421</height>
 <visible>true</visible>
 <uuid/>
 <bgcolor mode="background">
  <r>202</r>
  <g>200</g>
  <b>255</b>
 </bgcolor>
 <bsbObject version="2" type="BSBLabel">
  <objectName/>
  <x>142</x>
  <y>174</y>
  <width>461</width>
  <height>183</height>
  <uuid>{49bfb153-3c72-461b-b75f-52db6a63f015}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <label/>
  <alignment>left</alignment>
  <font>Arial</font>
  <fontsize>10</fontsize>
  <precision>3</precision>
  <color>
   <r>0</r>
   <g>0</g>
   <b>0</b>
  </color>
  <bgcolor mode="background">
   <r>102</r>
   <g>255</g>
   <b>153</b>
  </bgcolor>
  <bordermode>border</bordermode>
  <borderradius>6</borderradius>
  <borderwidth>1</borderwidth>
 </bsbObject>
 <bsbObject version="2" type="BSBLabel">
  <objectName/>
  <x>84</x>
  <y>8</y>
  <width>579</width>
  <height>101</height>
  <uuid>{951fe7d4-4247-432d-8eee-6e8889420259}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <label>CSOUND INSIDE
Enrico Francioni 
"Building Csound-based Systems for Realtime Chamber Music Performance"
TUTORIAL #5-01: "CLUSTER" (by E.Francioni)
example of live electronics based on timing</label>
  <alignment>center</alignment>
  <font>Arial</font>
  <fontsize>14</fontsize>
  <precision>3</precision>
  <color>
   <r>0</r>
   <g>0</g>
   <b>0</b>
  </color>
  <bgcolor mode="background">
   <r>204</r>
   <g>204</g>
   <b>204</b>
  </bgcolor>
  <bordermode>border</bordermode>
  <borderradius>1</borderradius>
  <borderwidth>1</borderwidth>
 </bsbObject>
 <bsbObject version="2" type="BSBDropdown">
  <objectName>in</objectName>
  <x>255</x>
  <y>264</y>
  <width>103</width>
  <height>28</height>
  <uuid>{a6f90fc2-1412-40f3-a203-50ed82f4c05f}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <bsbDropdownItemList>
   <bsbDropdownItem>
    <name>demo</name>
    <value>0</value>
    <stringvalue/>
   </bsbDropdownItem>
   <bsbDropdownItem>
    <name>mic</name>
    <value>1</value>
    <stringvalue/>
   </bsbDropdownItem>
  </bsbDropdownItemList>
  <selectedIndex>0</selectedIndex>
  <randomizable group="0">false</randomizable>
 </bsbObject>
 <bsbObject version="2" type="BSBLabel">
  <objectName/>
  <x>256</x>
  <y>232</y>
  <width>102</width>
  <height>28</height>
  <uuid>{ca74e6c5-ccda-478b-b0f3-990a6c42de87}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <label>SIGNAL</label>
  <alignment>center</alignment>
  <font>Arial</font>
  <fontsize>10</fontsize>
  <precision>3</precision>
  <color>
   <r>0</r>
   <g>0</g>
   <b>0</b>
  </color>
  <bgcolor mode="background">
   <r>255</r>
   <g>255</g>
   <b>255</b>
  </bgcolor>
  <bordermode>border</bordermode>
  <borderradius>1</borderradius>
  <borderwidth>1</borderwidth>
 </bsbObject>
 <bsbObject version="2" type="BSBLabel">
  <objectName/>
  <x>375</x>
  <y>232</y>
  <width>102</width>
  <height>28</height>
  <uuid>{c631e3cf-3aaa-4e4d-be56-ffd614949067}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <label>TIMER</label>
  <alignment>center</alignment>
  <font>Arial</font>
  <fontsize>10</fontsize>
  <precision>3</precision>
  <color>
   <r>0</r>
   <g>0</g>
   <b>0</b>
  </color>
  <bgcolor mode="background">
   <r>255</r>
   <g>255</g>
   <b>255</b>
  </bgcolor>
  <bordermode>border</bordermode>
  <borderradius>1</borderradius>
  <borderwidth>1</borderwidth>
 </bsbObject>
 <bsbObject version="2" type="BSBScrollNumber">
  <objectName>timer</objectName>
  <x>374</x>
  <y>265</y>
  <width>104</width>
  <height>28</height>
  <uuid>{6eb94ede-7389-4fae-9c02-afda5515c9cf}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <alignment>center</alignment>
  <font>Arial</font>
  <fontsize>12</fontsize>
  <color>
   <r>0</r>
   <g>0</g>
   <b>0</b>
  </color>
  <bgcolor mode="background">
   <r>255</r>
   <g>255</g>
   <b>255</b>
  </bgcolor>
  <value>10.00054359</value>
  <resolution>0.10000000</resolution>
  <minimum>0.00000000</minimum>
  <maximum>10.00000000</maximum>
  <bordermode>border</bordermode>
  <borderradius>1</borderradius>
  <borderwidth>1</borderwidth>
  <randomizable group="0">false</randomizable>
  <mouseControl act=""/>
 </bsbObject>
</bsbPanel>
<bsbPresets>
</bsbPresets>
<MacOptions>
Version: 3
Render: Real
Ask: Yes
Functions: ioObject
Listing: Window
WindowBounds: 72 179 400 200
CurrentView: io
IOViewEdit: On
Options:
</MacOptions>

<MacGUI>
ioView background {51914, 51400, 65535}
ioText {142, 174} {461, 183} label 0.000000 0.00100 "" left "Arial" 10 {0, 0, 0} {26112, 65280, 39168} nobackground noborder 
ioText {84, 8} {579, 101} label 0.000000 0.00100 "" center "Arial" 14 {0, 0, 0} {52224, 52224, 52224} nobackground noborder CSOUND INSIDEÂ¬Enrico Francioni Â¬"Building Csound-based Systems for Realtime Chamber Music Performance"Â¬TUTORIAL #5-01: "CLUSTER" (by E.Francioni)Â¬example of live electronics based on timing
ioMenu {255, 264} {103, 28} 0 303 "demo,mic" in
ioText {256, 232} {102, 28} label 0.000000 0.00100 "" center "Arial" 10 {0, 0, 0} {65280, 65280, 65280} nobackground noborder SIGNAL
ioText {375, 232} {102, 28} label 0.000000 0.00100 "" center "Arial" 10 {0, 0, 0} {65280, 65280, 65280} nobackground noborder TIMER
ioText {374, 265} {104, 28} scroll 10.000544 0.100000 "timer" center "Arial" 12 {0, 0, 0} {65280, 65280, 65280} background noborder 
</MacGUI>
