
/*
tutorial_#5-02

=====================
Six Online Tutorials:
=====================

The tutorials online propose ideas and approaches, which allow the user to problematize and then practice to do something to use for their own purposes.
Describes the stages of construction of some systems to help the reader, step by step, to learn to do something, to build patchs be used effectively in the performance.
Examples are some ideas to change, expand, or start from scratch using the same ideas or the same solutions and then realize their control systems.

=====================
ONLINE TUTORIAL #5
5. "CLUSTER" (by E.Francioni) - example of live electronics based on timing.
=====================

In this tutorial_#5-02 the selected signal enters in the algorithm on time by the score (action-time and duration) to be returned in output in real-time processed with FX.

Some observations:
     for orchestra
     - Listen to the exit in the left channel signal+FX, the original signal in the right channel

     Widgets in the Panel is given the opportunity to
     - Choose the type of input signal: "demo" (a fragment of CLUSTER) or "mic" (the microphone signal), before starting the algorithm;
     - Observe the timing of the timer.
    
*/

<CsoundSynthesizer>
<CsOptions>
</CsOptions>
<CsInstruments>

; header
sr		=	44100
ksmps		=	64
nchnls		=	2
0dbfs		=	1

;=================================================
	instr	1	; signal processing
;=================================================

ktinstr	timeinsts
outvalue	"timer", ktinstr

kin	invalue	"in"

if 		kin	== 0 then
aSIG		soundin	"demo.wav"
else
aSIG		inch	1
endif

; SILENCE
if 	(ktinstr	 >= 0) && (ktinstr < 3)	then
kgaincb	=	0

; SOUND + FX
elseif	(ktinstr	 >= 3) && (ktinstr < 6)	then
aosc	oscili	2, 300, 1
aRM	=	aSIG*(aosc*4)					; re-modulation signal (RM)
kgaincb	=	1

; SILENCE
elseif 	(ktinstr	 >= 6) && (ktinstr <= 10) then
kgaincb	=	0

endif

outs		aRM*kgaincb*.3, aSIG*kgaincb*.3		; output signal: the left channel signal+FX, the original signal in the right channel

endin


</CsInstruments>
<CsScore>
f1	0	1024	10	1				; function for the re-modulation (RM)
i1	0	10
e

</CsScore>
</CsoundSynthesizer><bsbPanel>
 <label>Widgets</label>
 <objectName/>
 <x>72</x>
 <y>179</y>
 <width>400</width>
 <height>200</height>
 <visible>true</visible>
 <uuid/>
 <bgcolor mode="background">
  <r>202</r>
  <g>200</g>
  <b>255</b>
 </bgcolor>
 <bsbObject version="2" type="BSBLabel">
  <objectName/>
  <x>142</x>
  <y>174</y>
  <width>461</width>
  <height>183</height>
  <uuid>{49bfb153-3c72-461b-b75f-52db6a63f015}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <label/>
  <alignment>left</alignment>
  <font>Arial</font>
  <fontsize>10</fontsize>
  <precision>3</precision>
  <color>
   <r>0</r>
   <g>0</g>
   <b>0</b>
  </color>
  <bgcolor mode="background">
   <r>102</r>
   <g>255</g>
   <b>153</b>
  </bgcolor>
  <bordermode>border</bordermode>
  <borderradius>6</borderradius>
  <borderwidth>1</borderwidth>
 </bsbObject>
 <bsbObject version="2" type="BSBLabel">
  <objectName/>
  <x>84</x>
  <y>8</y>
  <width>579</width>
  <height>93</height>
  <uuid>{951fe7d4-4247-432d-8eee-6e8889420259}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <label>CSOUND INSIDE
Enrico Francioni 
"Building Csound-based Systems for Realtime Chamber Music Performance"
TUTORIAL #5-02: "CLUSTER" (by E.Francioni)
example of live electronics based on timing</label>
  <alignment>center</alignment>
  <font>Arial</font>
  <fontsize>14</fontsize>
  <precision>3</precision>
  <color>
   <r>0</r>
   <g>0</g>
   <b>0</b>
  </color>
  <bgcolor mode="background">
   <r>204</r>
   <g>204</g>
   <b>204</b>
  </bgcolor>
  <bordermode>border</bordermode>
  <borderradius>1</borderradius>
  <borderwidth>1</borderwidth>
 </bsbObject>
 <bsbObject version="2" type="BSBDropdown">
  <objectName>in</objectName>
  <x>255</x>
  <y>264</y>
  <width>103</width>
  <height>28</height>
  <uuid>{a6f90fc2-1412-40f3-a203-50ed82f4c05f}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <bsbDropdownItemList>
   <bsbDropdownItem>
    <name>demo</name>
    <value>0</value>
    <stringvalue/>
   </bsbDropdownItem>
   <bsbDropdownItem>
    <name>mic</name>
    <value>1</value>
    <stringvalue/>
   </bsbDropdownItem>
  </bsbDropdownItemList>
  <selectedIndex>0</selectedIndex>
  <randomizable group="0">false</randomizable>
 </bsbObject>
 <bsbObject version="2" type="BSBLabel">
  <objectName/>
  <x>256</x>
  <y>232</y>
  <width>102</width>
  <height>28</height>
  <uuid>{ca74e6c5-ccda-478b-b0f3-990a6c42de87}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <label>SIGNAL</label>
  <alignment>center</alignment>
  <font>Arial</font>
  <fontsize>10</fontsize>
  <precision>3</precision>
  <color>
   <r>0</r>
   <g>0</g>
   <b>0</b>
  </color>
  <bgcolor mode="background">
   <r>255</r>
   <g>255</g>
   <b>255</b>
  </bgcolor>
  <bordermode>border</bordermode>
  <borderradius>1</borderradius>
  <borderwidth>1</borderwidth>
 </bsbObject>
 <bsbObject version="2" type="BSBLabel">
  <objectName/>
  <x>374</x>
  <y>231</y>
  <width>102</width>
  <height>28</height>
  <uuid>{c631e3cf-3aaa-4e4d-be56-ffd614949067}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <label>TIMER</label>
  <alignment>center</alignment>
  <font>Arial</font>
  <fontsize>10</fontsize>
  <precision>3</precision>
  <color>
   <r>0</r>
   <g>0</g>
   <b>0</b>
  </color>
  <bgcolor mode="background">
   <r>255</r>
   <g>255</g>
   <b>255</b>
  </bgcolor>
  <bordermode>border</bordermode>
  <borderradius>1</borderradius>
  <borderwidth>1</borderwidth>
 </bsbObject>
 <bsbObject version="2" type="BSBScrollNumber">
  <objectName>timer</objectName>
  <x>374</x>
  <y>265</y>
  <width>104</width>
  <height>28</height>
  <uuid>{6eb94ede-7389-4fae-9c02-afda5515c9cf}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <alignment>center</alignment>
  <font>Arial</font>
  <fontsize>12</fontsize>
  <color>
   <r>0</r>
   <g>0</g>
   <b>0</b>
  </color>
  <bgcolor mode="background">
   <r>255</r>
   <g>255</g>
   <b>255</b>
  </bgcolor>
  <value>10.00054359</value>
  <resolution>0.10000000</resolution>
  <minimum>0.00000000</minimum>
  <maximum>10.00000000</maximum>
  <bordermode>border</bordermode>
  <borderradius>1</borderradius>
  <borderwidth>1</borderwidth>
  <randomizable group="0">false</randomizable>
  <mouseControl act=""/>
 </bsbObject>
</bsbPanel>
<bsbPresets>
</bsbPresets>
<MacOptions>
Version: 3
Render: Real
Ask: Yes
Functions: ioObject
Listing: Window
WindowBounds: 72 179 400 200
CurrentView: io
IOViewEdit: On
Options:
</MacOptions>

<MacGUI>
ioView background {51914, 51400, 65535}
ioText {142, 174} {461, 183} label 0.000000 0.00100 "" left "Arial" 10 {0, 0, 0} {26112, 65280, 39168} nobackground noborder 
ioText {84, 8} {579, 93} label 0.000000 0.00100 "" center "Arial" 14 {0, 0, 0} {52224, 52224, 52224} nobackground noborder CSOUND INSIDEÂ¬Enrico Francioni Â¬"Building Csound-based Systems for Realtime Chamber Music Performance"Â¬TUTORIAL #5-02: "CLUSTER" (by E.Francioni)Â¬example of live electronics based on timing
ioMenu {255, 264} {103, 28} 0 303 "demo,mic" in
ioText {256, 232} {102, 28} label 0.000000 0.00100 "" center "Arial" 10 {0, 0, 0} {65280, 65280, 65280} nobackground noborder SIGNAL
ioText {374, 231} {102, 28} label 0.000000 0.00100 "" center "Arial" 10 {0, 0, 0} {65280, 65280, 65280} nobackground noborder TIMER
ioText {374, 265} {104, 28} scroll 10.000544 0.100000 "timer" center "Arial" 12 {0, 0, 0} {65280, 65280, 65280} background noborder 
</MacGUI>
