
/*
tutorial_#5-04

=====================
Six Online Tutorials:
=====================

The tutorials online propose ideas and approaches, which allow the user to problematize and then practice to do something to use for their own purposes.
Describes the stages of construction of some systems to help the reader, step by step, to learn to do something, to build patchs be used effectively in the performance.
Examples are some ideas to change, expand, or start from scratch using the same ideas or the same solutions and then realize their control systems.

=====================
ONLINE TUTORIAL #5
5. "CLUSTER" (by E.Francioni) - example of live electronics based on timing.
=====================

In this tutorial_#5-04 the selected signal enters in the algorithm on time by the score (action-time and duration), is returned in output in real-time (processed) and is simultaneously captured and then returned in output (unprocessed ) after a delay time established (with delay).

Some observations:
     for orchestra
    - In a first operation we hear the original signal output processed in the two channels;
    - In a second operation output we hear the original signal delayed in the two channels;

     Widgets in the Panel is given the opportunity to
     - Choose the type of input signal: "demo" (a fragment of CLUSTER) or "mic" (the microphone signal), before starting the algorithm;
     - Observe the timing of the timer;
     - Observe the controllers that light up respectively when the signal is captured (capture) and when it is returned after a delay (revived).

*/

<CsoundSynthesizer>
<CsOptions>
</CsOptions>
<CsInstruments>

; header
sr		=	44100
ksmps		=	64
nchnls		=	2
0dbfs		=	1

gaSIG		init	0
gktinstr		init	0

;=================================================
	instr	1	; signal processing
;=================================================

ktinstr	timeinsts
gktinstr	=	ktinstr
outvalue	"timer", ktinstr

kin	invalue	"in"

if 		kin	== 0 then
aSIG		soundin	"demo.wav"
else
aSIG		inch	1
endif

; SILENCE
if 	(ktinstr	 >= 0) && (ktinstr < 3)	then
outvalue	"capture", 0
kgaincb	=	0

; SOUND + CAPTURE + FX
elseif	(ktinstr	 >= 3) && (ktinstr < 6)	then
outvalue	"capture", 1
aosc	oscili	1, 300, 1
aRM	=	aSIG*(aosc*4)
gaSIG	=	aSIG
kgaincb	=	1

; SILENCE
elseif 	(ktinstr	 >= 6) && (ktinstr <= 10) then
outvalue	"capture", 0
kgaincb	=	0

endif

outs		aRM*kgaincb*.6, aRM*kgaincb*.1		; original signal processed output (unbalanced on the left channel)

endin

;=================================================
	instr	2	; signal revived
;=================================================

adelay	delay	gaSIG, 4

; SILENCE
if 	(gktinstr >= 0) && (gktinstr < 7)	then
outvalue	"revived", 0
kgaincb	=	0

; SOUND DELAY+ REVIVED
elseif 	(gktinstr >= 7) && (gktinstr <= 10) then
outvalue	"revived", 1
kgaincb	=	1

endif

outs	adelay*kgaincb*.1, adelay*kgaincb*.6
clear	gaSIG

endin


</CsInstruments>
<CsScore>
f1	0	1024	10	1
i1	0	10
i2	0	10
e

</CsScore>
</CsoundSynthesizer><bsbPanel>
 <label>Widgets</label>
 <objectName/>
 <x>72</x>
 <y>223</y>
 <width>762</width>
 <height>402</height>
 <visible>true</visible>
 <uuid/>
 <bgcolor mode="background">
  <r>202</r>
  <g>200</g>
  <b>255</b>
 </bgcolor>
 <bsbObject version="2" type="BSBLabel">
  <objectName/>
  <x>142</x>
  <y>174</y>
  <width>461</width>
  <height>183</height>
  <uuid>{49bfb153-3c72-461b-b75f-52db6a63f015}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <label/>
  <alignment>left</alignment>
  <font>Arial</font>
  <fontsize>10</fontsize>
  <precision>3</precision>
  <color>
   <r>0</r>
   <g>0</g>
   <b>0</b>
  </color>
  <bgcolor mode="background">
   <r>102</r>
   <g>255</g>
   <b>153</b>
  </bgcolor>
  <bordermode>border</bordermode>
  <borderradius>6</borderradius>
  <borderwidth>1</borderwidth>
 </bsbObject>
 <bsbObject version="2" type="BSBLabel">
  <objectName/>
  <x>84</x>
  <y>8</y>
  <width>579</width>
  <height>101</height>
  <uuid>{951fe7d4-4247-432d-8eee-6e8889420259}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <label>CSOUND INSIDE
Enrico Francioni 
"Building Csound-based Systems for Realtime Chamber Music Performance"
TUTORIAL #5-04: "CLUSTER" (by E.Francioni)
example of live electronics based on timing</label>
  <alignment>center</alignment>
  <font>Arial</font>
  <fontsize>14</fontsize>
  <precision>3</precision>
  <color>
   <r>0</r>
   <g>0</g>
   <b>0</b>
  </color>
  <bgcolor mode="background">
   <r>204</r>
   <g>204</g>
   <b>204</b>
  </bgcolor>
  <bordermode>border</bordermode>
  <borderradius>1</borderradius>
  <borderwidth>1</borderwidth>
 </bsbObject>
 <bsbObject version="2" type="BSBDropdown">
  <objectName>in</objectName>
  <x>164</x>
  <y>264</y>
  <width>103</width>
  <height>28</height>
  <uuid>{a6f90fc2-1412-40f3-a203-50ed82f4c05f}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <bsbDropdownItemList>
   <bsbDropdownItem>
    <name>demo</name>
    <value>0</value>
    <stringvalue/>
   </bsbDropdownItem>
   <bsbDropdownItem>
    <name>mic</name>
    <value>1</value>
    <stringvalue/>
   </bsbDropdownItem>
  </bsbDropdownItemList>
  <selectedIndex>0</selectedIndex>
  <randomizable group="0">false</randomizable>
 </bsbObject>
 <bsbObject version="2" type="BSBLabel">
  <objectName/>
  <x>165</x>
  <y>232</y>
  <width>102</width>
  <height>28</height>
  <uuid>{ca74e6c5-ccda-478b-b0f3-990a6c42de87}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <label>SIGNAL</label>
  <alignment>center</alignment>
  <font>Arial</font>
  <fontsize>10</fontsize>
  <precision>3</precision>
  <color>
   <r>0</r>
   <g>0</g>
   <b>0</b>
  </color>
  <bgcolor mode="background">
   <r>255</r>
   <g>255</g>
   <b>255</b>
  </bgcolor>
  <bordermode>border</bordermode>
  <borderradius>1</borderradius>
  <borderwidth>1</borderwidth>
 </bsbObject>
 <bsbObject version="2" type="BSBLabel">
  <objectName/>
  <x>492</x>
  <y>232</y>
  <width>102</width>
  <height>28</height>
  <uuid>{c631e3cf-3aaa-4e4d-be56-ffd614949067}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <label>TIMER</label>
  <alignment>center</alignment>
  <font>Arial</font>
  <fontsize>10</fontsize>
  <precision>3</precision>
  <color>
   <r>0</r>
   <g>0</g>
   <b>0</b>
  </color>
  <bgcolor mode="background">
   <r>255</r>
   <g>255</g>
   <b>255</b>
  </bgcolor>
  <bordermode>border</bordermode>
  <borderradius>1</borderradius>
  <borderwidth>1</borderwidth>
 </bsbObject>
 <bsbObject version="2" type="BSBScrollNumber">
  <objectName>timer</objectName>
  <x>491</x>
  <y>265</y>
  <width>104</width>
  <height>28</height>
  <uuid>{6eb94ede-7389-4fae-9c02-afda5515c9cf}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <alignment>center</alignment>
  <font>Arial</font>
  <fontsize>12</fontsize>
  <color>
   <r>0</r>
   <g>0</g>
   <b>0</b>
  </color>
  <bgcolor mode="background">
   <r>255</r>
   <g>255</g>
   <b>255</b>
  </bgcolor>
  <value>10.00054359</value>
  <resolution>0.10000000</resolution>
  <minimum>0.00000000</minimum>
  <maximum>10.00000000</maximum>
  <bordermode>border</bordermode>
  <borderradius>1</borderradius>
  <borderwidth>1</borderwidth>
  <randomizable group="0">false</randomizable>
  <mouseControl act=""/>
 </bsbObject>
 <bsbObject version="2" type="BSBController">
  <objectName>capture</objectName>
  <x>306</x>
  <y>264</y>
  <width>30</width>
  <height>29</height>
  <uuid>{2b0e5659-6c7f-4667-826b-2b2d8cce7c78}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <objectName2>capture</objectName2>
  <xMin>0.00000000</xMin>
  <xMax>1.00000000</xMax>
  <yMin>0.00000000</yMin>
  <yMax>1.00000000</yMax>
  <xValue>0.00000000</xValue>
  <yValue>0.00000000</yValue>
  <type>fill</type>
  <pointsize>1</pointsize>
  <fadeSpeed>0.00000000</fadeSpeed>
  <mouseControl act="press">jump</mouseControl>
  <color>
   <r>255</r>
   <g>0</g>
   <b>0</b>
  </color>
  <randomizable mode="both" group="0">false</randomizable>
  <bgcolor>
   <r>0</r>
   <g>0</g>
   <b>0</b>
  </bgcolor>
 </bsbObject>
 <bsbObject version="2" type="BSBLabel">
  <objectName/>
  <x>275</x>
  <y>232</y>
  <width>102</width>
  <height>28</height>
  <uuid>{fa113586-59e8-4794-95a8-056ab133f118}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <label>CAPTURE</label>
  <alignment>center</alignment>
  <font>Arial</font>
  <fontsize>10</fontsize>
  <precision>3</precision>
  <color>
   <r>0</r>
   <g>0</g>
   <b>0</b>
  </color>
  <bgcolor mode="background">
   <r>255</r>
   <g>255</g>
   <b>255</b>
  </bgcolor>
  <bordermode>border</bordermode>
  <borderradius>1</borderradius>
  <borderwidth>1</borderwidth>
 </bsbObject>
 <bsbObject version="2" type="BSBController">
  <objectName>revived</objectName>
  <x>414</x>
  <y>264</y>
  <width>30</width>
  <height>29</height>
  <uuid>{1dd38838-06f3-486c-8cb3-494a887a5320}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <objectName2>revived</objectName2>
  <xMin>0.00000000</xMin>
  <xMax>1.00000000</xMax>
  <yMin>0.00000000</yMin>
  <yMax>1.00000000</yMax>
  <xValue>1.00000000</xValue>
  <yValue>1.00000000</yValue>
  <type>fill</type>
  <pointsize>1</pointsize>
  <fadeSpeed>0.00000000</fadeSpeed>
  <mouseControl act="press">jump</mouseControl>
  <color>
   <r>64</r>
   <g>0</g>
   <b>128</b>
  </color>
  <randomizable mode="both" group="0">false</randomizable>
  <bgcolor>
   <r>0</r>
   <g>0</g>
   <b>0</b>
  </bgcolor>
 </bsbObject>
 <bsbObject version="2" type="BSBLabel">
  <objectName/>
  <x>383</x>
  <y>232</y>
  <width>102</width>
  <height>28</height>
  <uuid>{84935a7f-2369-42ee-8f5f-c7f583b981ae}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <label>REVIVED</label>
  <alignment>center</alignment>
  <font>Arial</font>
  <fontsize>10</fontsize>
  <precision>3</precision>
  <color>
   <r>0</r>
   <g>0</g>
   <b>0</b>
  </color>
  <bgcolor mode="background">
   <r>255</r>
   <g>255</g>
   <b>255</b>
  </bgcolor>
  <bordermode>border</bordermode>
  <borderradius>1</borderradius>
  <borderwidth>1</borderwidth>
 </bsbObject>
</bsbPanel>
<bsbPresets>
</bsbPresets>
<MacOptions>
Version: 3
Render: Real
Ask: Yes
Functions: ioObject
Listing: Window
WindowBounds: 72 179 400 200
CurrentView: io
IOViewEdit: On
Options:
</MacOptions>

<MacGUI>
ioView background {51914, 51400, 65535}
ioText {142, 174} {461, 183} label 0.000000 0.00100 "" left "Arial" 10 {0, 0, 0} {26112, 65280, 39168} nobackground noborder 
ioText {84, 8} {579, 101} label 0.000000 0.00100 "" center "Arial" 14 {0, 0, 0} {52224, 52224, 52224} nobackground noborder CSOUND INSIDEÂ¬Enrico Francioni Â¬"Building Csound-based Systems for Realtime Chamber Music Performance"Â¬TUTORIAL #5-04: "CLUSTER" (by E.Francioni)Â¬example of live electronics based on timing
ioMenu {164, 264} {103, 28} 0 303 "demo,mic" in
ioText {165, 232} {102, 28} label 0.000000 0.00100 "" center "Arial" 10 {0, 0, 0} {65280, 65280, 65280} nobackground noborder SIGNAL
ioText {492, 232} {102, 28} label 0.000000 0.00100 "" center "Arial" 10 {0, 0, 0} {65280, 65280, 65280} nobackground noborder TIMER
ioText {491, 265} {104, 28} scroll 10.000544 0.100000 "timer" center "Arial" 12 {0, 0, 0} {65280, 65280, 65280} background noborder 
ioMeter {306, 264} {30, 29} {65280, 0, 0} "capture" 0.000000 "capture" 0.000000 fill 1 0 mouse
ioText {275, 232} {102, 28} label 0.000000 0.00100 "" center "Arial" 10 {0, 0, 0} {65280, 65280, 65280} nobackground noborder CAPTURE
ioMeter {414, 264} {30, 29} {16384, 0, 32768} "revived" 1.000000 "revived" 1.000000 fill 1 0 mouse
ioText {383, 232} {102, 28} label 0.000000 0.00100 "" center "Arial" 10 {0, 0, 0} {65280, 65280, 65280} nobackground noborder REVIVED
</MacGUI>
