
/*
tutorial_#5-06

=====================
Six Online Tutorials:
=====================

The tutorials online propose ideas and approaches, which allow the user to problematize and then practice to do something to use for their own purposes.
Describes the stages of construction of some systems to help the reader, step by step, to learn to do something, to build patchs be used effectively in the performance.
Examples are some ideas to change, expand, or start from scratch using the same ideas or the same solutions and then realize their control systems.

=====================
ONLINE TUTORIAL #5
5. "CLUSTER" (by E.Francioni) - example of live electronics based on timing.
=====================

Using the same code base proposed for the tutorial_#4, this tutorial_#5-06 were prepared for the "One-man performance":

Some observations:
     the orchestra is enhanced by some tools
     - Instr 1 for the Play / Stop
     - Instr 3 for Metronome / Count-down
     - Instr 4 for the Timer
     - Instr 5 for Timeline
     - Instr 6 for the initial Reset the GUI
     - Instr 7 GUI (invalue / outvalue)
    
     Widgets Panel is also enriched with some useful tools for the "One-man performance"
     - A button for the PLAY / STOP
     - one ScrollNumber to quantify the value of the cCount-down;
     - A controller for the Metronome (MM = 60);
     - A controller for the Timeline;
     - A display (with giant digits) for the Timer;
     - A Console output window.
   
*/

<CsoundSynthesizer>
<CsOptions>
</CsOptions>
<CsInstruments>

; header
sr		=	44100
ksmps		=	64
nchnls		=	2
0dbfs		=	1

gkPlay		init	0
gkin		init	0
gaSIG		init	0
gktinstr		init	0
gkmtr1		init	0
gkmtr2		init	0
gkcdwn	init	0
gkph		init	0

;=======================================
	instr	Play	; caller	instrument
;=======================================

gkPlay	= 1 - gkPlay

	schedkwhen		gkPlay, -1, 1, 1, i(gkcdwn), 10
	schedkwhen		gkPlay, -1, 1, 2, i(gkcdwn),  10
	schedkwhen		gkPlay, -1, 1, 3, 0, 10+i(gkcdwn)
	schedkwhen		gkPlay, -1, 1, 4, 0, 10+i(gkcdwn)
	schedkwhen		gkPlay, -1, 1, 5, i(gkcdwn),  10		
	turnoff
	
	endin
		
		
;=======================================
	instr	1	; signal processing
;=======================================

if gkPlay != 0 goto cont
turnoff
cont:

if 		gkin	== 0 then
aSIG		soundin	"demo.wav"
else
aSIG		inch	1
endif

; SILENCE
if 	(gktinstr	 >= 0) && (gktinstr < 3)	then
outvalue	"capture", 0
kgaincb	=	0

; SOUND + CAPTURE + FX
elseif	(gktinstr	 >= 3) && (gktinstr < 6)	then
outvalue	"capture", 1
aosc	oscili	1, 300, 1
aRM	=	aSIG*(aosc*4)
gaSIG	=	aSIG
kgaincb	=	1

; SILENCE
elseif 	(gktinstr	 >= 6) && (gktinstr <= 10) then
outvalue	"capture", 0
kgaincb	=	0

endif

outs		aRM*kgaincb*.6, aRM*kgaincb*.1

	endin

;=======================================
	instr	2	; signal revived
;=======================================

if gkPlay != 0 goto cont
turnoff
cont:
    
adelay	delay	gaSIG, 4

; SILENCE
if 	(gktinstr >= 0) && (gktinstr < 7)	then
outvalue	"revived", 0
kgaincb	=	0

; SOUND DELAY+ REVIVED
elseif 	(gktinstr >= 7) && (gktinstr <= 10) then
outvalue	"revived", 1
kgaincb	=	1

endif

outs	adelay*kgaincb*.1, adelay*kgaincb*.6
clear	gaSIG

	endin

;=======================================
	instr	3	; metronome
;=======================================

if gkPlay != 0 goto cont
turnoff
cont:

ktinstr	timeinsts
kphsr 	phasor	 1

if kphsr >= .0009 && kphsr <= .2 then
	if	gkcdwn > 0 && ktinstr < gkcdwn then
	gkmtr2		=	1
	gkmtr1 	=	0
	else
	gkmtr2 	=	0
	gkmtr1 	=	1
	endif
	
else
gkmtr2		=	0		
gkmtr1		=	0 

endif

	endin
	
;=======================================
	instr	4	; timer
;=======================================

if gkPlay != 0 goto cont
turnoff
cont:

ktinstr		timeinsts
gktinstr		= ktinstr-i(gkcdwn)

	endin
		

;=======================================
	instr 5		; timeline
;=======================================

if gkPlay != 0 goto cont
turnoff
cont:

iTime	=	10
itime	=	1/iTime
ktime	line	itime, iTime, itime
gkph	phasor	ktime

endin

;=======================================
	instr	6	; gui-reset
;=======================================

; outvalue
outvalue	"play", 	0
outvalue	"timer", 0
outvalue 	"mtr", 0
outvalue 	"Mctwn", 0
outvalue	"revived", 0
outvalue	"capture", 0
outvalue	"timeline", 0

	turnoff
	endin
	
;=======================================
	instr	7	; gui
;=======================================

; invalue
gkin		invalue	"in"
gkcdwn	invalue 	"cdwn"

; outvalue
outvalue	"play", 	gkPlay
outvalue	"timer", gktinstr
outvalue 	"mtr", gkmtr1
outvalue 	"Mctwn", gkmtr2
outvalue	"timeline", gkph

	endin


	

</CsInstruments>
<CsScore>
f0	3600
f1	0	1024	10	1
i6	0	-1
i7	.01	-1
e

</CsScore>
</CsoundSynthesizer><bsbPanel>
 <label>Widgets</label>
 <objectName/>
 <x>0</x>
 <y>66</y>
 <width>1439</width>
 <height>856</height>
 <visible>true</visible>
 <uuid/>
 <bgcolor mode="background">
  <r>202</r>
  <g>200</g>
  <b>255</b>
 </bgcolor>
 <bsbObject version="2" type="BSBLabel">
  <objectName/>
  <x>418</x>
  <y>4</y>
  <width>610</width>
  <height>109</height>
  <uuid>{951fe7d4-4247-432d-8eee-6e8889420259}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <label>CSOUND INSIDE
Enrico Francioni 
"Building Csound-based Systems for Realtime Chamber Music Performance"
TUTORIAL #5-06: "CLUSTER" (by E.Francioni)
example of live electronics based on timing</label>
  <alignment>center</alignment>
  <font>Arial</font>
  <fontsize>14</fontsize>
  <precision>3</precision>
  <color>
   <r>0</r>
   <g>0</g>
   <b>0</b>
  </color>
  <bgcolor mode="background">
   <r>204</r>
   <g>204</g>
   <b>204</b>
  </bgcolor>
  <bordermode>border</bordermode>
  <borderradius>1</borderradius>
  <borderwidth>1</borderwidth>
 </bsbObject>
 <bsbObject version="2" type="BSBConsole">
  <objectName>_Console</objectName>
  <x>927</x>
  <y>161</y>
  <width>385</width>
  <height>161</height>
  <uuid>{0dcf559d-9ef3-4913-b93c-4e9ab27d7f44}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <font>Courier</font>
  <fontsize>8</fontsize>
  <color>
   <r>0</r>
   <g>0</g>
   <b>0</b>
  </color>
  <bgcolor mode="nobackground">
   <r>255</r>
   <g>255</g>
   <b>255</b>
  </bgcolor>
 </bsbObject>
 <bsbObject version="2" type="BSBButton">
  <objectName>play</objectName>
  <x>632</x>
  <y>129</y>
  <width>201</width>
  <height>80</height>
  <uuid>{ca0cee78-4c81-4fb8-80a3-cc38eeefcb03}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <type>event</type>
  <pressedValue>1.00000000</pressedValue>
  <stringvalue/>
  <text>PLAY/STOP</text>
  <image>/</image>
  <eventLine>i"Play" 0 .1</eventLine>
  <latch>true</latch>
  <latched>false</latched>
 </bsbObject>
 <bsbObject version="2" type="BSBDisplay">
  <objectName>timer</objectName>
  <x>416</x>
  <y>455</y>
  <width>600</width>
  <height>228</height>
  <uuid>{e8c4b495-5cde-4b14-893c-dcdafa4173de}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <label>0.000</label>
  <alignment>center</alignment>
  <font>Lucida Grande</font>
  <fontsize>180</fontsize>
  <precision>3</precision>
  <color>
   <r>0</r>
   <g>0</g>
   <b>128</b>
  </color>
  <bgcolor mode="background">
   <r>230</r>
   <g>230</g>
   <b>230</b>
  </bgcolor>
  <bordermode>border</bordermode>
  <borderradius>1</borderradius>
  <borderwidth>1</borderwidth>
 </bsbObject>
 <bsbObject version="2" type="BSBController">
  <objectName>Mctwn</objectName>
  <x>92</x>
  <y>464</y>
  <width>199</width>
  <height>192</height>
  <uuid>{b23798c8-920a-46ed-97cb-92f107664948}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>-3</midicc>
  <objectName2>Mctwn</objectName2>
  <xMin>0.00000000</xMin>
  <xMax>1.00000000</xMax>
  <yMin>0.00000000</yMin>
  <yMax>1.00000000</yMax>
  <xValue>0.00000000</xValue>
  <yValue>0.00000000</yValue>
  <type>fill</type>
  <pointsize>8</pointsize>
  <fadeSpeed>97.00000000</fadeSpeed>
  <mouseControl act="press">jump</mouseControl>
  <color>
   <r>255</r>
   <g>0</g>
   <b>0</b>
  </color>
  <randomizable mode="both" group="0">false</randomizable>
  <bgcolor>
   <r>0</r>
   <g>0</g>
   <b>0</b>
  </bgcolor>
 </bsbObject>
 <bsbObject version="2" type="BSBController">
  <objectName>mtr</objectName>
  <x>1119</x>
  <y>462</y>
  <width>199</width>
  <height>192</height>
  <uuid>{c487d479-861c-4338-aea9-b8c47423bf1c}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <objectName2>mtr</objectName2>
  <xMin>0.00000000</xMin>
  <xMax>1.00000000</xMax>
  <yMin>0.00000000</yMin>
  <yMax>1.00000000</yMax>
  <xValue>0.00000000</xValue>
  <yValue>0.00000000</yValue>
  <type>fill</type>
  <pointsize>8</pointsize>
  <fadeSpeed>0.00000000</fadeSpeed>
  <mouseControl act="press">jump</mouseControl>
  <color>
   <r>255</r>
   <g>255</g>
   <b>0</b>
  </color>
  <randomizable mode="both" group="0">false</randomizable>
  <bgcolor>
   <r>0</r>
   <g>0</g>
   <b>0</b>
  </bgcolor>
 </bsbObject>
 <bsbObject version="2" type="BSBLabel">
  <objectName/>
  <x>113</x>
  <y>430</y>
  <width>114</width>
  <height>32</height>
  <uuid>{a9fff42b-6a82-4ae4-b602-3adf1e1d2c00}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <label>count_down</label>
  <alignment>center</alignment>
  <font>Lucida Grande</font>
  <fontsize>14</fontsize>
  <precision>3</precision>
  <color>
   <r>0</r>
   <g>0</g>
   <b>0</b>
  </color>
  <bgcolor mode="background">
   <r>255</r>
   <g>255</g>
   <b>255</b>
  </bgcolor>
  <bordermode>border</bordermode>
  <borderradius>1</borderradius>
  <borderwidth>1</borderwidth>
 </bsbObject>
 <bsbObject version="2" type="BSBLabel">
  <objectName/>
  <x>1136</x>
  <y>427</y>
  <width>166</width>
  <height>32</height>
  <uuid>{a483e4e9-9cca-4c17-9e75-1ad743e4bed8}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <label>metronome</label>
  <alignment>center</alignment>
  <font>Lucida Grande</font>
  <fontsize>14</fontsize>
  <precision>3</precision>
  <color>
   <r>0</r>
   <g>0</g>
   <b>0</b>
  </color>
  <bgcolor mode="background">
   <r>255</r>
   <g>255</g>
   <b>255</b>
  </bgcolor>
  <bordermode>border</bordermode>
  <borderradius>1</borderradius>
  <borderwidth>1</borderwidth>
 </bsbObject>
 <bsbObject version="2" type="BSBController">
  <objectName>capture</objectName>
  <x>655</x>
  <y>356</y>
  <width>38</width>
  <height>37</height>
  <uuid>{812044cc-0eb3-496e-ade3-dadf49e39a31}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <objectName2>capture</objectName2>
  <xMin>0.00000000</xMin>
  <xMax>1.00000000</xMax>
  <yMin>0.00000000</yMin>
  <yMax>1.00000000</yMax>
  <xValue>0.00000000</xValue>
  <yValue>0.00000000</yValue>
  <type>fill</type>
  <pointsize>1</pointsize>
  <fadeSpeed>0.00000000</fadeSpeed>
  <mouseControl act="press">jump</mouseControl>
  <color>
   <r>255</r>
   <g>0</g>
   <b>0</b>
  </color>
  <randomizable mode="both" group="0">false</randomizable>
  <bgcolor>
   <r>0</r>
   <g>0</g>
   <b>0</b>
  </bgcolor>
 </bsbObject>
 <bsbObject version="2" type="BSBController">
  <objectName>revived</objectName>
  <x>757</x>
  <y>355</y>
  <width>38</width>
  <height>37</height>
  <uuid>{d3285337-cf2c-4c58-ae03-701ba5956e7d}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <objectName2>revived</objectName2>
  <xMin>0.00000000</xMin>
  <xMax>1.00000000</xMax>
  <yMin>0.00000000</yMin>
  <yMax>1.00000000</yMax>
  <xValue>0.00000000</xValue>
  <yValue>0.00000000</yValue>
  <type>fill</type>
  <pointsize>1</pointsize>
  <fadeSpeed>0.00000000</fadeSpeed>
  <mouseControl act="press">jump</mouseControl>
  <color>
   <r>0</r>
   <g>0</g>
   <b>255</b>
  </color>
  <randomizable mode="both" group="0">false</randomizable>
  <bgcolor>
   <r>0</r>
   <g>0</g>
   <b>0</b>
  </bgcolor>
 </bsbObject>
 <bsbObject version="2" type="BSBController">
  <objectName>timeline</objectName>
  <x>90</x>
  <y>723</y>
  <width>1231</width>
  <height>51</height>
  <uuid>{0f96641e-1f32-47dd-a71f-8bfae304bb76}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <objectName2>timeline</objectName2>
  <xMin>0.00000000</xMin>
  <xMax>1.00000000</xMax>
  <yMin>0.00000000</yMin>
  <yMax>1.00000000</yMax>
  <xValue>0.00000000</xValue>
  <yValue>0.00000000</yValue>
  <type>fill</type>
  <pointsize>70</pointsize>
  <fadeSpeed>0.00000000</fadeSpeed>
  <mouseControl act="press">jump</mouseControl>
  <color>
   <r>230</r>
   <g>230</g>
   <b>230</b>
  </color>
  <randomizable mode="both" group="0">false</randomizable>
  <bgcolor>
   <r>0</r>
   <g>0</g>
   <b>0</b>
  </bgcolor>
 </bsbObject>
 <bsbObject version="2" type="BSBLabel">
  <objectName/>
  <x>91</x>
  <y>692</y>
  <width>80</width>
  <height>27</height>
  <uuid>{fd04c95e-c290-447c-a02a-b2a8c50cf201}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <label>time-line</label>
  <alignment>center</alignment>
  <font>Lucida Grande</font>
  <fontsize>10</fontsize>
  <precision>3</precision>
  <color>
   <r>64</r>
   <g>0</g>
   <b>128</b>
  </color>
  <bgcolor mode="background">
   <r>255</r>
   <g>255</g>
   <b>255</b>
  </bgcolor>
  <bordermode>border</bordermode>
  <borderradius>1</borderradius>
  <borderwidth>1</borderwidth>
 </bsbObject>
 <bsbObject version="2" type="BSBLabel">
  <objectName/>
  <x>1247</x>
  <y>131</y>
  <width>64</width>
  <height>28</height>
  <uuid>{e0c7e7b4-cb53-44c9-86ed-1a0d0a2689c4}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <label>message</label>
  <alignment>center</alignment>
  <font>Lucida Grande</font>
  <fontsize>12</fontsize>
  <precision>3</precision>
  <color>
   <r>64</r>
   <g>0</g>
   <b>128</b>
  </color>
  <bgcolor mode="background">
   <r>255</r>
   <g>255</g>
   <b>255</b>
  </bgcolor>
  <bordermode>border</bordermode>
  <borderradius>1</borderradius>
  <borderwidth>1</borderwidth>
 </bsbObject>
 <bsbObject version="2" type="BSBDropdown">
  <objectName>in</objectName>
  <x>658</x>
  <y>270</y>
  <width>142</width>
  <height>38</height>
  <uuid>{8b34b578-361a-4ae5-a6ec-4f0632e0e2e3}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <bsbDropdownItemList>
   <bsbDropdownItem>
    <name>DEMO</name>
    <value>0</value>
    <stringvalue/>
   </bsbDropdownItem>
   <bsbDropdownItem>
    <name>MIC</name>
    <value>1</value>
    <stringvalue/>
   </bsbDropdownItem>
  </bsbDropdownItemList>
  <selectedIndex>0</selectedIndex>
  <randomizable group="0">false</randomizable>
 </bsbObject>
 <bsbObject version="2" type="BSBLabel">
  <objectName/>
  <x>663</x>
  <y>242</y>
  <width>132</width>
  <height>28</height>
  <uuid>{24a0bc29-1712-46fa-8321-2352ef5d85b1}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <label>SIGNAL</label>
  <alignment>center</alignment>
  <font>Lucida Grande</font>
  <fontsize>14</fontsize>
  <precision>3</precision>
  <color>
   <r>0</r>
   <g>0</g>
   <b>0</b>
  </color>
  <bgcolor mode="background">
   <r>255</r>
   <g>255</g>
   <b>255</b>
  </bgcolor>
  <bordermode>border</bordermode>
  <borderradius>1</borderradius>
  <borderwidth>1</borderwidth>
 </bsbObject>
 <bsbObject version="2" type="BSBScrollNumber">
  <objectName>cdwn</objectName>
  <x>229</x>
  <y>430</y>
  <width>40</width>
  <height>32</height>
  <uuid>{5b6d2e2c-26b2-4e76-a6dc-dc52309af1b7}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <alignment>right</alignment>
  <font>Arial</font>
  <fontsize>20</fontsize>
  <color>
   <r>0</r>
   <g>0</g>
   <b>0</b>
  </color>
  <bgcolor mode="background">
   <r>255</r>
   <g>255</g>
   <b>255</b>
  </bgcolor>
  <value>2.00000000</value>
  <resolution>1.00000000</resolution>
  <minimum>0.00000000</minimum>
  <maximum>10.00000000</maximum>
  <bordermode>border</bordermode>
  <borderradius>1</borderradius>
  <borderwidth>1</borderwidth>
  <randomizable group="0">false</randomizable>
  <mouseControl act=""/>
 </bsbObject>
 <bsbObject version="2" type="BSBLabel">
  <objectName/>
  <x>619</x>
  <y>398</y>
  <width>102</width>
  <height>28</height>
  <uuid>{fa113586-59e8-4794-95a8-056ab133f118}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <label>CAPTURE</label>
  <alignment>center</alignment>
  <font>Arial</font>
  <fontsize>10</fontsize>
  <precision>3</precision>
  <color>
   <r>0</r>
   <g>0</g>
   <b>0</b>
  </color>
  <bgcolor mode="background">
   <r>255</r>
   <g>255</g>
   <b>255</b>
  </bgcolor>
  <bordermode>border</bordermode>
  <borderradius>1</borderradius>
  <borderwidth>1</borderwidth>
 </bsbObject>
 <bsbObject version="2" type="BSBLabel">
  <objectName/>
  <x>728</x>
  <y>398</y>
  <width>102</width>
  <height>28</height>
  <uuid>{84935a7f-2369-42ee-8f5f-c7f583b981ae}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <label>REVIVED</label>
  <alignment>center</alignment>
  <font>Arial</font>
  <fontsize>10</fontsize>
  <precision>3</precision>
  <color>
   <r>0</r>
   <g>0</g>
   <b>0</b>
  </color>
  <bgcolor mode="background">
   <r>255</r>
   <g>255</g>
   <b>255</b>
  </bgcolor>
  <bordermode>border</bordermode>
  <borderradius>1</borderradius>
  <borderwidth>1</borderwidth>
 </bsbObject>
 <bsbObject version="2" type="BSBLabel">
  <objectName/>
  <x>417</x>
  <y>426</y>
  <width>102</width>
  <height>28</height>
  <uuid>{c631e3cf-3aaa-4e4d-be56-ffd614949067}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <label>TIMER</label>
  <alignment>center</alignment>
  <font>Arial</font>
  <fontsize>10</fontsize>
  <precision>3</precision>
  <color>
   <r>0</r>
   <g>0</g>
   <b>0</b>
  </color>
  <bgcolor mode="background">
   <r>255</r>
   <g>255</g>
   <b>255</b>
  </bgcolor>
  <bordermode>border</bordermode>
  <borderradius>1</borderradius>
  <borderwidth>1</borderwidth>
 </bsbObject>
</bsbPanel>
<bsbPresets>
</bsbPresets>
<MacOptions>
Version: 3
Render: Real
Ask: Yes
Functions: ioObject
Listing: Window
WindowBounds: 72 179 400 200
CurrentView: io
IOViewEdit: On
Options:
</MacOptions>

<MacGUI>
ioView background {51914, 51400, 65535}
ioText {418, 4} {610, 109} label 0.000000 0.00100 "" center "Arial" 14 {0, 0, 0} {52224, 52224, 52224} nobackground noborder CSOUND INSIDEÂ¬Enrico Francioni Â¬"Building Csound-based Systems for Realtime Chamber Music Performance"Â¬TUTORIAL #5-06: "CLUSTER" (by E.Francioni)Â¬example of live electronics based on timing
ioListing {927, 161} {385, 161}
ioButton {632, 129} {201, 80} event 1.000000 "play" "PLAY/STOP" "/" i"Play" 0 .1
ioText {416, 455} {600, 228} display 0.000000 0.00100 "timer" center "Lucida Grande" 180 {0, 0, 32768} {58880, 58880, 58880} nobackground noborder 0.000
ioMeter {92, 464} {199, 192} {65280, 0, 0} "Mctwn" 0.000000 "Mctwn" 0.000000 fill 8 0 mouse
ioMeter {1119, 462} {199, 192} {65280, 65280, 0} "mtr" 0.000000 "mtr" 0.000000 fill 8 0 mouse
ioText {113, 430} {114, 32} label 0.000000 0.00100 "" center "Lucida Grande" 14 {0, 0, 0} {65280, 65280, 65280} nobackground noborder count_down
ioText {1136, 427} {166, 32} label 0.000000 0.00100 "" center "Lucida Grande" 14 {0, 0, 0} {65280, 65280, 65280} nobackground noborder metronome
ioMeter {655, 356} {38, 37} {65280, 0, 0} "capture" 0.000000 "capture" 0.000000 fill 1 0 mouse
ioMeter {757, 355} {38, 37} {0, 0, 65280} "revived" 0.000000 "revived" 0.000000 fill 1 0 mouse
ioMeter {90, 723} {1231, 51} {58880, 58880, 58880} "timeline" 0.000000 "timeline" 0.000000 fill 70 0 mouse
ioText {91, 692} {80, 27} label 0.000000 0.00100 "" center "Lucida Grande" 10 {16384, 0, 32768} {65280, 65280, 65280} nobackground noborder time-line
ioText {1247, 131} {64, 28} label 0.000000 0.00100 "" center "Lucida Grande" 12 {16384, 0, 32768} {65280, 65280, 65280} nobackground noborder message
ioMenu {658, 270} {142, 38} 0 303 "DEMO,MIC" in
ioText {663, 242} {132, 28} label 0.000000 0.00100 "" center "Lucida Grande" 14 {0, 0, 0} {65280, 65280, 65280} nobackground noborder SIGNAL
ioText {229, 430} {40, 32} scroll 2.000000 1.000000 "cdwn" right "Arial" 20 {0, 0, 0} {65280, 65280, 65280} background noborder 
ioText {619, 398} {102, 28} label 0.000000 0.00100 "" center "Arial" 10 {0, 0, 0} {65280, 65280, 65280} nobackground noborder CAPTURE
ioText {728, 398} {102, 28} label 0.000000 0.00100 "" center "Arial" 10 {0, 0, 0} {65280, 65280, 65280} nobackground noborder REVIVED
ioText {417, 426} {102, 28} label 0.000000 0.00100 "" center "Arial" 10 {0, 0, 0} {65280, 65280, 65280} nobackground noborder TIMER
</MacGUI>
