
/*
tutorial_#6-06

=====================
Six Online Tutorials:
=====================

The tutorials online propose ideas and approaches, which allow the user to problematize and then practice to do something to use for their own purposes.
Describes the stages of construction of some systems to help the reader, step by step, to learn to do something, to build patchs be used effectively in the performance.
Examples are some ideas to change, expand, or start from scratch using the same ideas or the same solutions and then realize their control systems.

=====================
ONLINE TUTORIAL #6
6. "eSpace" (by E.Francioni) - example of realtime spatialization of multichannel signals.
=====================

In this last tutorial_#6-06 are joined five patchs in a single algorithm; Widgets Panel from here we can decide in real time what course to give the signal.
N.B. For successful execution of the algorithm with spatial 4-channel [nchnls = 4] is necessary to interface a sound card to 4 output channels and one input channel; alternatively it is important to keep nchnls = 2.

Some observations:
     for orchestra
    - Through a Matrix it is given that can go to call the desired instrument that corresponds to a particular type of conduct of the signal (from the Widgets Panel);
     - Immediately after the Run of the algorithm or where instruments called the Matrix become inactive, instr 6 outputs the signal located at coordinates x = 0 / y = 0;

     in the Widgets panel
     - Is given the option to choose the type of signal with Menu.

*/

<CsoundSynthesizer>
<CsOptions>
</CsOptions>
<CsInstruments>

; header
sr		=	44100
ksmps		=	64
nchnls_i	=	1
nchnls		=	2
; nchnls	=	4
0dbfs		=	1

gasig	init	0		; global variable audio - main signal

;===========================================
#define TRUE #1#	; MACRO - boolean true
#define FALSE #0#	; MACRO - boolean false
;===========================================

;===========================================
	instr signal		; SIGNAL
;===========================================

ksig	invalue "sig"		; choosing the type of signal from the Widgets Panel

if 	ksig == 0 then
asig	inch	1		; import of the microphone signal - Channel 1
elseif 	ksig == 1 then
asig	rand	.7		; white-noise
elseif 	ksig == 2 then
asig	oscili	.7, 440, 1	; wave-sine
endif

gasig	= gasig+asig		; globalization of the audio signal

	endin

;===========================================
	instr matrix 		; MATRIX - for the choice of instrument to be activated
;===========================================

if p4 == 1 igoto Joystik
if p4 == 2 igoto Lines
if p4 == 3 igoto Circles
if p4 == 4 igoto Random
if p4 == 5 igoto Pingpong

Joystik:
gkbutton1 init $TRUE
gkbutton2 init $FALSE
gkbutton3 init $FALSE
gkbutton4 init $FALSE
gkbutton5 init $FALSE

schedule 1, 1/kr, -1	; 1/kr to avoid minor bugs; It is essentially a delay (delay) of the one cycle (kr)

igoto end

Lines:
gkbutton2 init $TRUE
gkbutton1 init $FALSE
gkbutton3 init $FALSE
gkbutton4 init $FALSE
gkbutton5 init $FALSE

schedule 2, 1/kr, 30

igoto end

Circles:
gkbutton3 init $TRUE
gkbutton1 init $FALSE
gkbutton2 init $FALSE
gkbutton4 init $FALSE
gkbutton5 init $FALSE

schedule 3, 1/kr, 30

igoto end

Random:
gkbutton4 init $TRUE
gkbutton1 init $FALSE
gkbutton2 init $FALSE
gkbutton3 init $FALSE
gkbutton5 init $FALSE

schedule 4, 1/kr, 30

igoto end

Pingpong:
gkbutton5 init $TRUE
gkbutton1 init $FALSE
gkbutton2 init $FALSE
gkbutton3 init $FALSE
gkbutton4 init $FALSE

schedule 5, 1/kr, 60

end:
turnoff

endin

;===========================================
	instr 1 	; Joystick
;===========================================
if gkbutton1 == $TRUE  kgoto contin	; conditional step to continue
turnoff
contin:
    
kx_in	invalue	"x1in"
ky_in	invalue	"y1in"

kxx 	port	kx_in, .05		; applies portamento to a step-valued control signal
kyy	port	ky_in, .05		; applies portamento to a step-valued control signal

ir		=	2
kx	=	(kxx * ir) - (ir * .5)
ky	=	(kyy * ir) - (ir * .5)

a1, a2, a3, a4		space	gasig, 0, 0, 0, kx, ky

		outvalue	"x1out", kx
		outvalue	"y1out", ky

outch	1, a1, 2, a2, 3, a3, 4, a4
clear	gasig
	endin
		
;===========================================
	instr 2 	; Lines
;===========================================
if gkbutton2 == $TRUE  kgoto contin	; conditional step to continue
turnoff
contin:
    
reset:

idur_seg 	= p3/2
idur		= idur_seg * (1/9) 

ia		=	-1
ib		=	1

kx linseg ia, idur, ib, idur, ib, idur, ia, idur, ia, idur, ib, idur, ib, idur, ia, idur, ib, idur, ia
ky linseg ib, idur, ib, idur, ia, idur, ia, idur, ib, idur, ia, idur, ib, idur, ia, idur, ia, idur, ib

timout 0, idur_seg, continue
reinit reset
continue:
rireturn 

a1, a2, a3, a4		space	gasig, 0, 0, 0, kx, ky

ir		=	2.25
kx_c	=	(kx + (ir * .5)) / ir
ky_c	=	(ky + (ir * .5)) / ir

outvalue	"x2out", kx_c
outvalue	"y2out", ky_c
outvalue	"xd2out", kx
outvalue	"yd2out", ky

outch	1, a1, 2, a2, 3, a3, 4, a4
clear	gasig
	endin

;===========================================
	instr 3 	; Circles
;===========================================
if gkbutton3 == $TRUE  kgoto contin	; conditional step to continue
turnoff
contin:

reset:

kangolo 	init	3.14159
inc		=	-6.2832
incr		=	inc / p3 / kr*10
kangolo	=	kangolo + incr

kx		=	cos(kangolo)
ky		=	sin(kangolo)	

idur_seg = p3/10

timout 0, idur_seg, continua
reinit reset

continua:
rireturn

a1, a2, a3, a4 space	gasig, 0, 0, 0, kx, ky

ir	=	2.25
kx_c	=	(kx + (ir * .5)) / ir
ky_c	=	(ky + (ir * .5)) / ir
		
		outvalue	"x3out", kx_c
		outvalue	"y3out", ky_c
		outvalue	"xd3out", kx
		outvalue	"yd3out", ky

outch	1, a1, 2, a2, 3, a3, 4, a4
clear	gasig	
	endin

;===========================================
	instr 4 	; Random
;===========================================
if gkbutton4 == $TRUE  kgoto contin	; conditional step to continue
turnoff
contin:

kxx		randh	1, 2, 1.5
kyy		randh	1, 3, 1.5

kx	port	kxx, .0075		; applies portamento to a step-valued control signal
ky	port	kyy, .0075		; applies portamento to a step-valued control signal

a1, a2, a3, a4 space	gasig, 0, 0, 0, kx, ky

ir	=	2.25
kx_c	=	(kx + (ir * .5)) / ir
ky_c	=	(ky + (ir * .5)) / ir
		
		outvalue	"x4out", kx_c
		outvalue	"y4out", ky_c
		outvalue	"xd4out", kx
		outvalue	"yd4out", ky

outch	1, a1, 2, a2, 3, a3, 4, a4
clear	gasig		
	endin

;===========================================
	instr 5		; Ping-pong
;===========================================
if gkbutton5 == $TRUE  kgoto contin	; conditional step to continue
turnoff
contin:
    
kvelX	line	rnd(.4), p3, rnd(.5)+.4
kvelY	line	rnd(.5)+.4, p3, rnd(.4)

kx	oscili		1, kvelX, 2
ky	oscili		1, kvelY, 2

a1, a2, a3, a4 		space	gasig, 0, 0, 0, kx, ky

ir		=	2
kx_c	=	(kx + (ir * .5)) / ir
ky_c	=	(ky + (ir * .5)) / ir

		outvalue	"xd5out", kx
		outvalue	"yd5out", ky
		outvalue	"pingx", kx_c
		outvalue	"pongy", ky_c

outch	1, a1, 2, a2, 3, a3, 4, a4
clear	gasig		
	endin

;===========================================
	instr 6		; active-instruments
;===========================================

; verification active instruments
kres1	active	1
kres2	active	2
kres3	active	3
kres4	active	4
kres5	active	5

if kres1 == 0 && kres2 == 0 && kres3 == 0 && kres4 == 0 && kres5 == 0 then	; if the instruments are all inactive then ...
a1, a2, a3, a4 		space	gasig, 0, 0, 0, 0, 0					; the signal is spatialized (x = 0 y = 0)
outch	1, a1, 2, a2, 3, a3, 4, a4							; output on four channels
clear	gasig										; zeroes a list of audio signals

else											; otherwise ... (if the instruments are active)
goto end										; It goes to the label "end"
endif											; end of conditional step

end:											; label
	endin
		
</CsInstruments>
<CsScore>
f1	0	1024	10	1
f2	0	1024	7	-1	512	1	512	-1
i"signal"	0	3600
i6		0	3600
e 3600

</CsScore>
</CsoundSynthesizer><bsbPanel>
 <label>Widgets</label>
 <objectName/>
 <x>0</x>
 <y>44</y>
 <width>1441</width>
 <height>856</height>
 <visible>true</visible>
 <uuid/>
 <bgcolor mode="background">
  <r>91</r>
  <g>91</g>
  <b>91</b>
 </bgcolor>
 <bsbObject version="2" type="BSBButton">
  <objectName/>
  <x>627</x>
  <y>131</y>
  <width>115</width>
  <height>45</height>
  <uuid>{1cfeefbb-94e9-4445-9f8b-25532a1c60cd}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <type>event</type>
  <pressedValue>1.00000000</pressedValue>
  <stringvalue/>
  <text>Joystick</text>
  <image>/</image>
  <eventLine>i"matrix" 0 -1 1</eventLine>
  <latch>false</latch>
  <latched>false</latched>
 </bsbObject>
 <bsbObject version="2" type="BSBLabel">
  <objectName/>
  <x>432</x>
  <y>6</y>
  <width>511</width>
  <height>104</height>
  <uuid>{951fe7d4-4247-432d-8eee-6e8889420259}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <label>CSOUND INSIDE
Enrico Francioni 
"Building Csound-based Systems for Realtime Chamber Music Performance"
TUTORIAL #6-06: "eSpace" (by E.Francioni) - example of realtime spatialization of multichannel signals.</label>
  <alignment>center</alignment>
  <font>Arial</font>
  <fontsize>14</fontsize>
  <precision>3</precision>
  <color>
   <r>0</r>
   <g>0</g>
   <b>0</b>
  </color>
  <bgcolor mode="background">
   <r>204</r>
   <g>204</g>
   <b>204</b>
  </bgcolor>
  <bordermode>border</bordermode>
  <borderradius>1</borderradius>
  <borderwidth>1</borderwidth>
 </bsbObject>
 <bsbObject version="2" type="BSBController">
  <objectName>x1in</objectName>
  <x>405</x>
  <y>183</y>
  <width>551</width>
  <height>551</height>
  <uuid>{5fcb3bd4-1b5c-4b20-a563-b8b9d74ce5c9}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <objectName2>y1in</objectName2>
  <xMin>0.00000000</xMin>
  <xMax>1.00000000</xMax>
  <yMin>0.00000000</yMin>
  <yMax>1.00000000</yMax>
  <xValue>0.50635209</xValue>
  <yValue>0.38294011</yValue>
  <type>point</type>
  <pointsize>13</pointsize>
  <fadeSpeed>99.00000000</fadeSpeed>
  <mouseControl act="press">jump</mouseControl>
  <color>
   <r>255</r>
   <g>128</g>
   <b>0</b>
  </color>
  <randomizable mode="both" group="0">false</randomizable>
  <bgcolor>
   <r>0</r>
   <g>0</g>
   <b>0</b>
  </bgcolor>
 </bsbObject>
 <bsbObject version="2" type="BSBLabel">
  <objectName/>
  <x>666</x>
  <y>766</y>
  <width>53</width>
  <height>31</height>
  <uuid>{ae6bc59e-dbf9-43aa-a156-f9bef315b309}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>-3</midicc>
  <label>x</label>
  <alignment>center</alignment>
  <font>Lucida Grande</font>
  <fontsize>18</fontsize>
  <precision>3</precision>
  <color>
   <r>255</r>
   <g>255</g>
   <b>255</b>
  </color>
  <bgcolor mode="nobackground">
   <r>0</r>
   <g>87</g>
   <b>121</b>
  </bgcolor>
  <bordermode>noborder</bordermode>
  <borderradius>1</borderradius>
  <borderwidth>1</borderwidth>
 </bsbObject>
 <bsbObject version="2" type="BSBDisplay">
  <objectName>y1out</objectName>
  <x>347</x>
  <y>448</y>
  <width>53</width>
  <height>26</height>
  <uuid>{d2ba19f9-ff0f-4e58-8652-f2c400006a36}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <label>-0.234</label>
  <alignment>center</alignment>
  <font>Lucida Grande</font>
  <fontsize>14</fontsize>
  <precision>3</precision>
  <color>
   <r>255</r>
   <g>255</g>
   <b>255</b>
  </color>
  <bgcolor mode="nobackground">
   <r>0</r>
   <g>0</g>
   <b>0</b>
  </bgcolor>
  <bordermode>noborder</bordermode>
  <borderradius>1</borderradius>
  <borderwidth>1</borderwidth>
 </bsbObject>
 <bsbObject version="2" type="BSBDisplay">
  <objectName>x1out</objectName>
  <x>665</x>
  <y>739</y>
  <width>54</width>
  <height>27</height>
  <uuid>{b97596e9-7856-4575-a445-be38e3951cdc}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <label>0.013</label>
  <alignment>center</alignment>
  <font>Lucida Grande</font>
  <fontsize>14</fontsize>
  <precision>3</precision>
  <color>
   <r>255</r>
   <g>255</g>
   <b>255</b>
  </color>
  <bgcolor mode="nobackground">
   <r>0</r>
   <g>0</g>
   <b>0</b>
  </bgcolor>
  <bordermode>noborder</bordermode>
  <borderradius>1</borderradius>
  <borderwidth>1</borderwidth>
 </bsbObject>
 <bsbObject version="2" type="BSBLabel">
  <objectName/>
  <x>347</x>
  <y>412</y>
  <width>53</width>
  <height>31</height>
  <uuid>{9068be6f-1cc4-486b-993c-750743b938fa}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>-3</midicc>
  <label>y</label>
  <alignment>center</alignment>
  <font>Lucida Grande</font>
  <fontsize>18</fontsize>
  <precision>3</precision>
  <color>
   <r>255</r>
   <g>255</g>
   <b>255</b>
  </color>
  <bgcolor mode="nobackground">
   <r>0</r>
   <g>87</g>
   <b>121</b>
  </bgcolor>
  <bordermode>noborder</bordermode>
  <borderradius>1</borderradius>
  <borderwidth>1</borderwidth>
 </bsbObject>
 <bsbObject version="2" type="BSBLabel">
  <objectName/>
  <x>382</x>
  <y>161</y>
  <width>24</width>
  <height>24</height>
  <uuid>{58bb1b38-d1d2-4277-80fc-623dd0f58d90}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>-3</midicc>
  <label>Lf</label>
  <alignment>center</alignment>
  <font>Lucida Grande</font>
  <fontsize>12</fontsize>
  <precision>3</precision>
  <color>
   <r>230</r>
   <g>230</g>
   <b>230</b>
  </color>
  <bgcolor mode="nobackground">
   <r>255</r>
   <g>255</g>
   <b>255</b>
  </bgcolor>
  <bordermode>noborder</bordermode>
  <borderradius>1</borderradius>
  <borderwidth>1</borderwidth>
 </bsbObject>
 <bsbObject version="2" type="BSBLabel">
  <objectName/>
  <x>954</x>
  <y>160</y>
  <width>24</width>
  <height>24</height>
  <uuid>{02ee7586-a222-4e18-8860-436bcc34cbb8}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>-3</midicc>
  <label>Rf</label>
  <alignment>center</alignment>
  <font>Lucida Grande</font>
  <fontsize>12</fontsize>
  <precision>3</precision>
  <color>
   <r>230</r>
   <g>230</g>
   <b>230</b>
  </color>
  <bgcolor mode="nobackground">
   <r>255</r>
   <g>255</g>
   <b>255</b>
  </bgcolor>
  <bordermode>noborder</bordermode>
  <borderradius>1</borderradius>
  <borderwidth>1</borderwidth>
 </bsbObject>
 <bsbObject version="2" type="BSBLabel">
  <objectName/>
  <x>382</x>
  <y>732</y>
  <width>24</width>
  <height>24</height>
  <uuid>{7195c6c2-3e95-4428-b6c2-b71ddcb583e7}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>-3</midicc>
  <label>Lr</label>
  <alignment>center</alignment>
  <font>Lucida Grande</font>
  <fontsize>12</fontsize>
  <precision>3</precision>
  <color>
   <r>230</r>
   <g>230</g>
   <b>230</b>
  </color>
  <bgcolor mode="nobackground">
   <r>255</r>
   <g>255</g>
   <b>255</b>
  </bgcolor>
  <bordermode>noborder</bordermode>
  <borderradius>1</borderradius>
  <borderwidth>1</borderwidth>
 </bsbObject>
 <bsbObject version="2" type="BSBLabel">
  <objectName/>
  <x>955</x>
  <y>733</y>
  <width>24</width>
  <height>24</height>
  <uuid>{3b3de6da-5434-41af-ba3a-26d730e42432}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>-3</midicc>
  <label>Rr</label>
  <alignment>center</alignment>
  <font>Lucida Grande</font>
  <fontsize>12</fontsize>
  <precision>3</precision>
  <color>
   <r>230</r>
   <g>230</g>
   <b>230</b>
  </color>
  <bgcolor mode="nobackground">
   <r>255</r>
   <g>255</g>
   <b>255</b>
  </bgcolor>
  <bordermode>noborder</bordermode>
  <borderradius>1</borderradius>
  <borderwidth>1</borderwidth>
 </bsbObject>
 <bsbObject version="2" type="BSBButton">
  <objectName/>
  <x>1140</x>
  <y>489</y>
  <width>115</width>
  <height>45</height>
  <uuid>{723e0c18-4870-446b-ac81-70bf05a6bfcd}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <type>event</type>
  <pressedValue>1.00000000</pressedValue>
  <stringvalue/>
  <text>Ping-pong</text>
  <image>/</image>
  <eventLine>i"matrix" 0 -1 5</eventLine>
  <latch>false</latch>
  <latched>false</latched>
 </bsbObject>
 <bsbObject version="2" type="BSBController">
  <objectName>pingx</objectName>
  <x>1095</x>
  <y>536</y>
  <width>195</width>
  <height>195</height>
  <uuid>{707fb675-3e10-421e-ac1e-07c2d197da3d}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <objectName2>pongy</objectName2>
  <xMin>0.00000000</xMin>
  <xMax>1.00000000</xMax>
  <yMin>0.00000000</yMin>
  <yMax>1.00000000</yMax>
  <xValue>0.44858193</xValue>
  <yValue>0.14792073</yValue>
  <type>point</type>
  <pointsize>6</pointsize>
  <fadeSpeed>35.00000000</fadeSpeed>
  <mouseControl act="press">jump</mouseControl>
  <color>
   <r>255</r>
   <g>255</g>
   <b>0</b>
  </color>
  <randomizable mode="both" group="0">false</randomizable>
  <bgcolor>
   <r>0</r>
   <g>0</g>
   <b>0</b>
  </bgcolor>
 </bsbObject>
 <bsbObject version="2" type="BSBDisplay">
  <objectName>yd5out</objectName>
  <x>1020</x>
  <y>618</y>
  <width>82</width>
  <height>23</height>
  <uuid>{f134650b-a01d-466b-ac44-5a396487d801}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <label>-0.704</label>
  <alignment>center</alignment>
  <font>Lucida Grande</font>
  <fontsize>8</fontsize>
  <precision>3</precision>
  <color>
   <r>255</r>
   <g>255</g>
   <b>255</b>
  </color>
  <bgcolor mode="nobackground">
   <r>0</r>
   <g>0</g>
   <b>0</b>
  </bgcolor>
  <bordermode>noborder</bordermode>
  <borderradius>1</borderradius>
  <borderwidth>1</borderwidth>
 </bsbObject>
 <bsbObject version="2" type="BSBDisplay">
  <objectName>xd5out</objectName>
  <x>1157</x>
  <y>732</y>
  <width>71</width>
  <height>25</height>
  <uuid>{8b3a6861-d4a5-4a05-b0f4-072ab6a14d27}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <label>-0.103</label>
  <alignment>center</alignment>
  <font>Lucida Grande</font>
  <fontsize>8</fontsize>
  <precision>3</precision>
  <color>
   <r>255</r>
   <g>255</g>
   <b>255</b>
  </color>
  <bgcolor mode="nobackground">
   <r>0</r>
   <g>0</g>
   <b>0</b>
  </bgcolor>
  <bordermode>noborder</bordermode>
  <borderradius>1</borderradius>
  <borderwidth>1</borderwidth>
 </bsbObject>
 <bsbObject version="2" type="BSBLabel">
  <objectName/>
  <x>1075</x>
  <y>512</y>
  <width>24</width>
  <height>24</height>
  <uuid>{d926e46f-3c78-4b57-861b-d009b5dc998c}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <label>Lf</label>
  <alignment>center</alignment>
  <font>Lucida Grande</font>
  <fontsize>10</fontsize>
  <precision>3</precision>
  <color>
   <r>230</r>
   <g>230</g>
   <b>230</b>
  </color>
  <bgcolor mode="nobackground">
   <r>255</r>
   <g>255</g>
   <b>255</b>
  </bgcolor>
  <bordermode>noborder</bordermode>
  <borderradius>1</borderradius>
  <borderwidth>1</borderwidth>
 </bsbObject>
 <bsbObject version="2" type="BSBLabel">
  <objectName/>
  <x>1289</x>
  <y>513</y>
  <width>24</width>
  <height>24</height>
  <uuid>{306f3527-44e4-4708-b067-75442045e22d}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <label>Rf</label>
  <alignment>center</alignment>
  <font>Lucida Grande</font>
  <fontsize>10</fontsize>
  <precision>3</precision>
  <color>
   <r>230</r>
   <g>230</g>
   <b>230</b>
  </color>
  <bgcolor mode="nobackground">
   <r>255</r>
   <g>255</g>
   <b>255</b>
  </bgcolor>
  <bordermode>noborder</bordermode>
  <borderradius>1</borderradius>
  <borderwidth>1</borderwidth>
 </bsbObject>
 <bsbObject version="2" type="BSBLabel">
  <objectName/>
  <x>1289</x>
  <y>728</y>
  <width>24</width>
  <height>24</height>
  <uuid>{3df97e25-a818-47a9-9772-86a996d6b42f}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <label>Rr</label>
  <alignment>center</alignment>
  <font>Lucida Grande</font>
  <fontsize>10</fontsize>
  <precision>3</precision>
  <color>
   <r>230</r>
   <g>230</g>
   <b>230</b>
  </color>
  <bgcolor mode="nobackground">
   <r>255</r>
   <g>255</g>
   <b>255</b>
  </bgcolor>
  <bordermode>noborder</bordermode>
  <borderradius>1</borderradius>
  <borderwidth>1</borderwidth>
 </bsbObject>
 <bsbObject version="2" type="BSBLabel">
  <objectName/>
  <x>1073</x>
  <y>727</y>
  <width>24</width>
  <height>24</height>
  <uuid>{b225fba9-f41f-4ec5-ab23-6e8b420c89a9}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <label>Lr</label>
  <alignment>center</alignment>
  <font>Lucida Grande</font>
  <fontsize>10</fontsize>
  <precision>3</precision>
  <color>
   <r>230</r>
   <g>230</g>
   <b>230</b>
  </color>
  <bgcolor mode="nobackground">
   <r>255</r>
   <g>255</g>
   <b>255</b>
  </bgcolor>
  <bordermode>noborder</bordermode>
  <borderradius>1</borderradius>
  <borderwidth>1</borderwidth>
 </bsbObject>
 <bsbObject version="2" type="BSBLabel">
  <objectName/>
  <x>1180</x>
  <y>751</y>
  <width>24</width>
  <height>24</height>
  <uuid>{66ced349-5c9b-46b3-a03b-8a68da8c9e88}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <label>x</label>
  <alignment>center</alignment>
  <font>Lucida Grande</font>
  <fontsize>10</fontsize>
  <precision>3</precision>
  <color>
   <r>230</r>
   <g>230</g>
   <b>230</b>
  </color>
  <bgcolor mode="nobackground">
   <r>255</r>
   <g>255</g>
   <b>255</b>
  </bgcolor>
  <bordermode>noborder</bordermode>
  <borderradius>1</borderradius>
  <borderwidth>1</borderwidth>
 </bsbObject>
 <bsbObject version="2" type="BSBLabel">
  <objectName/>
  <x>1049</x>
  <y>593</y>
  <width>24</width>
  <height>24</height>
  <uuid>{f5ab5e7b-df29-4baf-80b1-f37ad6b55e51}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <label>y</label>
  <alignment>center</alignment>
  <font>Lucida Grande</font>
  <fontsize>10</fontsize>
  <precision>3</precision>
  <color>
   <r>230</r>
   <g>230</g>
   <b>230</b>
  </color>
  <bgcolor mode="nobackground">
   <r>255</r>
   <g>255</g>
   <b>255</b>
  </bgcolor>
  <bordermode>noborder</bordermode>
  <borderradius>1</borderradius>
  <borderwidth>1</borderwidth>
 </bsbObject>
 <bsbObject version="2" type="BSBButton">
  <objectName/>
  <x>1137</x>
  <y>139</y>
  <width>115</width>
  <height>45</height>
  <uuid>{ea29545e-22db-4146-9c9c-2f51e3b0a108}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <type>event</type>
  <pressedValue>1.00000000</pressedValue>
  <stringvalue/>
  <text>Random</text>
  <image>/</image>
  <eventLine>i"matrix" 0 -1 4</eventLine>
  <latch>false</latch>
  <latched>false</latched>
 </bsbObject>
 <bsbObject version="2" type="BSBController">
  <objectName>x4out</objectName>
  <x>1092</x>
  <y>186</y>
  <width>195</width>
  <height>195</height>
  <uuid>{b4186e45-78dc-46fc-8a64-2bc03b4d32b5}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <objectName2>y4out</objectName2>
  <xMin>0.00000000</xMin>
  <xMax>1.00000000</xMax>
  <yMin>0.00000000</yMin>
  <yMax>1.00000000</yMax>
  <xValue>0.65231663</xValue>
  <yValue>0.89628094</yValue>
  <type>point</type>
  <pointsize>6</pointsize>
  <fadeSpeed>35.00000000</fadeSpeed>
  <mouseControl act="press">jump</mouseControl>
  <color>
   <r>255</r>
   <g>255</g>
   <b>0</b>
  </color>
  <randomizable mode="both" group="0">false</randomizable>
  <bgcolor>
   <r>0</r>
   <g>0</g>
   <b>0</b>
  </bgcolor>
 </bsbObject>
 <bsbObject version="2" type="BSBDisplay">
  <objectName>yd4out</objectName>
  <x>1017</x>
  <y>268</y>
  <width>82</width>
  <height>23</height>
  <uuid>{aa50b77b-7176-4ecf-bdf1-6f5452b6f774}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <label>0.892</label>
  <alignment>center</alignment>
  <font>Lucida Grande</font>
  <fontsize>8</fontsize>
  <precision>3</precision>
  <color>
   <r>255</r>
   <g>255</g>
   <b>255</b>
  </color>
  <bgcolor mode="nobackground">
   <r>0</r>
   <g>0</g>
   <b>0</b>
  </bgcolor>
  <bordermode>noborder</bordermode>
  <borderradius>1</borderradius>
  <borderwidth>1</borderwidth>
 </bsbObject>
 <bsbObject version="2" type="BSBDisplay">
  <objectName>xd4out</objectName>
  <x>1154</x>
  <y>382</y>
  <width>71</width>
  <height>25</height>
  <uuid>{c8b767b3-b61d-4d92-9670-5ca36a5f7e5c}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <label>0.343</label>
  <alignment>center</alignment>
  <font>Lucida Grande</font>
  <fontsize>8</fontsize>
  <precision>3</precision>
  <color>
   <r>255</r>
   <g>255</g>
   <b>255</b>
  </color>
  <bgcolor mode="nobackground">
   <r>0</r>
   <g>0</g>
   <b>0</b>
  </bgcolor>
  <bordermode>noborder</bordermode>
  <borderradius>1</borderradius>
  <borderwidth>1</borderwidth>
 </bsbObject>
 <bsbObject version="2" type="BSBLabel">
  <objectName/>
  <x>1072</x>
  <y>162</y>
  <width>24</width>
  <height>24</height>
  <uuid>{1c00cd10-3fed-45a7-9a87-aca7aeac6c24}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <label>Lf</label>
  <alignment>center</alignment>
  <font>Lucida Grande</font>
  <fontsize>10</fontsize>
  <precision>3</precision>
  <color>
   <r>230</r>
   <g>230</g>
   <b>230</b>
  </color>
  <bgcolor mode="nobackground">
   <r>255</r>
   <g>255</g>
   <b>255</b>
  </bgcolor>
  <bordermode>noborder</bordermode>
  <borderradius>1</borderradius>
  <borderwidth>1</borderwidth>
 </bsbObject>
 <bsbObject version="2" type="BSBLabel">
  <objectName/>
  <x>1286</x>
  <y>163</y>
  <width>24</width>
  <height>24</height>
  <uuid>{e4eca026-8f50-4bd9-856e-9ffe6c8eded7}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <label>Rf</label>
  <alignment>center</alignment>
  <font>Lucida Grande</font>
  <fontsize>10</fontsize>
  <precision>3</precision>
  <color>
   <r>230</r>
   <g>230</g>
   <b>230</b>
  </color>
  <bgcolor mode="nobackground">
   <r>255</r>
   <g>255</g>
   <b>255</b>
  </bgcolor>
  <bordermode>noborder</bordermode>
  <borderradius>1</borderradius>
  <borderwidth>1</borderwidth>
 </bsbObject>
 <bsbObject version="2" type="BSBLabel">
  <objectName/>
  <x>1286</x>
  <y>378</y>
  <width>24</width>
  <height>24</height>
  <uuid>{b9ec3eec-1d93-416b-bf0b-ee0ae3125aae}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <label>Rr</label>
  <alignment>center</alignment>
  <font>Lucida Grande</font>
  <fontsize>10</fontsize>
  <precision>3</precision>
  <color>
   <r>230</r>
   <g>230</g>
   <b>230</b>
  </color>
  <bgcolor mode="nobackground">
   <r>255</r>
   <g>255</g>
   <b>255</b>
  </bgcolor>
  <bordermode>noborder</bordermode>
  <borderradius>1</borderradius>
  <borderwidth>1</borderwidth>
 </bsbObject>
 <bsbObject version="2" type="BSBLabel">
  <objectName/>
  <x>1070</x>
  <y>377</y>
  <width>24</width>
  <height>24</height>
  <uuid>{17b4adc4-1524-49f4-b83c-960a1e785e56}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <label>Lr</label>
  <alignment>center</alignment>
  <font>Lucida Grande</font>
  <fontsize>10</fontsize>
  <precision>3</precision>
  <color>
   <r>230</r>
   <g>230</g>
   <b>230</b>
  </color>
  <bgcolor mode="nobackground">
   <r>255</r>
   <g>255</g>
   <b>255</b>
  </bgcolor>
  <bordermode>noborder</bordermode>
  <borderradius>1</borderradius>
  <borderwidth>1</borderwidth>
 </bsbObject>
 <bsbObject version="2" type="BSBLabel">
  <objectName/>
  <x>1177</x>
  <y>401</y>
  <width>24</width>
  <height>24</height>
  <uuid>{e2f3e1eb-e1a1-4da9-a1cd-f776caadc7f7}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <label>x</label>
  <alignment>center</alignment>
  <font>Lucida Grande</font>
  <fontsize>10</fontsize>
  <precision>3</precision>
  <color>
   <r>230</r>
   <g>230</g>
   <b>230</b>
  </color>
  <bgcolor mode="nobackground">
   <r>255</r>
   <g>255</g>
   <b>255</b>
  </bgcolor>
  <bordermode>noborder</bordermode>
  <borderradius>1</borderradius>
  <borderwidth>1</borderwidth>
 </bsbObject>
 <bsbObject version="2" type="BSBLabel">
  <objectName/>
  <x>1046</x>
  <y>243</y>
  <width>24</width>
  <height>24</height>
  <uuid>{f5c672c1-4147-4c21-abe2-26bb8427ec66}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <label>y</label>
  <alignment>center</alignment>
  <font>Lucida Grande</font>
  <fontsize>10</fontsize>
  <precision>3</precision>
  <color>
   <r>230</r>
   <g>230</g>
   <b>230</b>
  </color>
  <bgcolor mode="nobackground">
   <r>255</r>
   <g>255</g>
   <b>255</b>
  </bgcolor>
  <bordermode>noborder</bordermode>
  <borderradius>1</borderradius>
  <borderwidth>1</borderwidth>
 </bsbObject>
 <bsbObject version="2" type="BSBButton">
  <objectName/>
  <x>131</x>
  <y>490</y>
  <width>115</width>
  <height>45</height>
  <uuid>{a754bcc3-f55e-4d2c-944d-9358097db7bc}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <type>event</type>
  <pressedValue>1.00000000</pressedValue>
  <stringvalue/>
  <text>Circles</text>
  <image>/</image>
  <eventLine>i"matrix" 0 -1 3</eventLine>
  <latch>false</latch>
  <latched>false</latched>
 </bsbObject>
 <bsbObject version="2" type="BSBController">
  <objectName>x3out</objectName>
  <x>86</x>
  <y>537</y>
  <width>195</width>
  <height>195</height>
  <uuid>{e30aa895-8e1b-45e9-b43e-42b408001f5e}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <objectName2>y3out</objectName2>
  <xMin>0.00000000</xMin>
  <xMax>1.00000000</xMax>
  <yMin>0.00000000</yMin>
  <yMax>1.00000000</yMax>
  <xValue>0.41856852</xValue>
  <yValue>0.06307920</yValue>
  <type>point</type>
  <pointsize>6</pointsize>
  <fadeSpeed>35.00000000</fadeSpeed>
  <mouseControl act="press">jump</mouseControl>
  <color>
   <r>255</r>
   <g>255</g>
   <b>0</b>
  </color>
  <randomizable mode="both" group="0">false</randomizable>
  <bgcolor>
   <r>0</r>
   <g>0</g>
   <b>0</b>
  </bgcolor>
 </bsbObject>
 <bsbObject version="2" type="BSBLabel">
  <objectName/>
  <x>66</x>
  <y>513</y>
  <width>24</width>
  <height>24</height>
  <uuid>{74f42268-daf0-43e8-a885-aa2788dadd13}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <label>Lf</label>
  <alignment>center</alignment>
  <font>Lucida Grande</font>
  <fontsize>10</fontsize>
  <precision>3</precision>
  <color>
   <r>230</r>
   <g>230</g>
   <b>230</b>
  </color>
  <bgcolor mode="nobackground">
   <r>255</r>
   <g>255</g>
   <b>255</b>
  </bgcolor>
  <bordermode>noborder</bordermode>
  <borderradius>1</borderradius>
  <borderwidth>1</borderwidth>
 </bsbObject>
 <bsbObject version="2" type="BSBLabel">
  <objectName/>
  <x>280</x>
  <y>514</y>
  <width>24</width>
  <height>24</height>
  <uuid>{e6552e5b-6fc8-40e0-a731-3f44ffcde84d}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <label>Rf</label>
  <alignment>center</alignment>
  <font>Lucida Grande</font>
  <fontsize>10</fontsize>
  <precision>3</precision>
  <color>
   <r>230</r>
   <g>230</g>
   <b>230</b>
  </color>
  <bgcolor mode="nobackground">
   <r>255</r>
   <g>255</g>
   <b>255</b>
  </bgcolor>
  <bordermode>noborder</bordermode>
  <borderradius>1</borderradius>
  <borderwidth>1</borderwidth>
 </bsbObject>
 <bsbObject version="2" type="BSBLabel">
  <objectName/>
  <x>280</x>
  <y>729</y>
  <width>24</width>
  <height>24</height>
  <uuid>{54a90f1e-7672-43c8-9ff6-60900baf4afb}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <label>Rr</label>
  <alignment>center</alignment>
  <font>Lucida Grande</font>
  <fontsize>10</fontsize>
  <precision>3</precision>
  <color>
   <r>230</r>
   <g>230</g>
   <b>230</b>
  </color>
  <bgcolor mode="nobackground">
   <r>255</r>
   <g>255</g>
   <b>255</b>
  </bgcolor>
  <bordermode>noborder</bordermode>
  <borderradius>1</borderradius>
  <borderwidth>1</borderwidth>
 </bsbObject>
 <bsbObject version="2" type="BSBLabel">
  <objectName/>
  <x>64</x>
  <y>728</y>
  <width>24</width>
  <height>24</height>
  <uuid>{6f00dc8d-4b08-48c3-af64-2e7688ab6f8b}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <label>Lr</label>
  <alignment>center</alignment>
  <font>Lucida Grande</font>
  <fontsize>10</fontsize>
  <precision>3</precision>
  <color>
   <r>230</r>
   <g>230</g>
   <b>230</b>
  </color>
  <bgcolor mode="nobackground">
   <r>255</r>
   <g>255</g>
   <b>255</b>
  </bgcolor>
  <bordermode>noborder</bordermode>
  <borderradius>1</borderradius>
  <borderwidth>1</borderwidth>
 </bsbObject>
 <bsbObject version="2" type="BSBDisplay">
  <objectName>yd3out</objectName>
  <x>8</x>
  <y>616</y>
  <width>82</width>
  <height>23</height>
  <uuid>{8ba6fbd8-0f44-4712-88c5-bd725b70cd33}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <label>-0.983</label>
  <alignment>center</alignment>
  <font>Lucida Grande</font>
  <fontsize>8</fontsize>
  <precision>3</precision>
  <color>
   <r>255</r>
   <g>255</g>
   <b>255</b>
  </color>
  <bgcolor mode="nobackground">
   <r>0</r>
   <g>0</g>
   <b>0</b>
  </bgcolor>
  <bordermode>noborder</bordermode>
  <borderradius>1</borderradius>
  <borderwidth>1</borderwidth>
 </bsbObject>
 <bsbObject version="2" type="BSBDisplay">
  <objectName>xd3out</objectName>
  <x>144</x>
  <y>730</y>
  <width>71</width>
  <height>25</height>
  <uuid>{558f5732-3d77-4263-95a7-2534714c6d66}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <label>-0.183</label>
  <alignment>center</alignment>
  <font>Lucida Grande</font>
  <fontsize>8</fontsize>
  <precision>3</precision>
  <color>
   <r>255</r>
   <g>255</g>
   <b>255</b>
  </color>
  <bgcolor mode="nobackground">
   <r>0</r>
   <g>0</g>
   <b>0</b>
  </bgcolor>
  <bordermode>noborder</bordermode>
  <borderradius>1</borderradius>
  <borderwidth>1</borderwidth>
 </bsbObject>
 <bsbObject version="2" type="BSBLabel">
  <objectName/>
  <x>167</x>
  <y>749</y>
  <width>24</width>
  <height>24</height>
  <uuid>{ddef331b-23ad-4cde-b729-280870eafa6b}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <label>x</label>
  <alignment>center</alignment>
  <font>Lucida Grande</font>
  <fontsize>10</fontsize>
  <precision>3</precision>
  <color>
   <r>230</r>
   <g>230</g>
   <b>230</b>
  </color>
  <bgcolor mode="nobackground">
   <r>255</r>
   <g>255</g>
   <b>255</b>
  </bgcolor>
  <bordermode>noborder</bordermode>
  <borderradius>1</borderradius>
  <borderwidth>1</borderwidth>
 </bsbObject>
 <bsbObject version="2" type="BSBLabel">
  <objectName/>
  <x>36</x>
  <y>591</y>
  <width>24</width>
  <height>24</height>
  <uuid>{a0b2c7e6-939f-4c86-91ce-4428448ad71f}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <label>y</label>
  <alignment>center</alignment>
  <font>Lucida Grande</font>
  <fontsize>10</fontsize>
  <precision>3</precision>
  <color>
   <r>230</r>
   <g>230</g>
   <b>230</b>
  </color>
  <bgcolor mode="nobackground">
   <r>255</r>
   <g>255</g>
   <b>255</b>
  </bgcolor>
  <bordermode>noborder</bordermode>
  <borderradius>1</borderradius>
  <borderwidth>1</borderwidth>
 </bsbObject>
 <bsbObject version="2" type="BSBButton">
  <objectName/>
  <x>128</x>
  <y>137</y>
  <width>115</width>
  <height>45</height>
  <uuid>{5107dbdf-a04f-4cff-8b33-9a722fd4cdb8}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <type>event</type>
  <pressedValue>1.00000000</pressedValue>
  <stringvalue/>
  <text>Lines</text>
  <image>/</image>
  <eventLine>i"matrix" 0 -1 2</eventLine>
  <latch>false</latch>
  <latched>false</latched>
 </bsbObject>
 <bsbObject version="2" type="BSBController">
  <objectName>x2out</objectName>
  <x>83</x>
  <y>184</y>
  <width>195</width>
  <height>195</height>
  <uuid>{42e9ea84-0891-42e9-b8f8-3e6747c1654e}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <objectName2>y2out</objectName2>
  <xMin>0.00000000</xMin>
  <xMax>1.00000000</xMax>
  <yMin>0.00000000</yMin>
  <yMax>1.00000000</yMax>
  <xValue>0.88405377</xValue>
  <yValue>0.94444442</yValue>
  <type>point</type>
  <pointsize>6</pointsize>
  <fadeSpeed>35.00000000</fadeSpeed>
  <mouseControl act="press">jump</mouseControl>
  <color>
   <r>255</r>
   <g>255</g>
   <b>0</b>
  </color>
  <randomizable mode="both" group="0">false</randomizable>
  <bgcolor>
   <r>0</r>
   <g>0</g>
   <b>0</b>
  </bgcolor>
 </bsbObject>
 <bsbObject version="2" type="BSBLabel">
  <objectName/>
  <x>63</x>
  <y>160</y>
  <width>24</width>
  <height>24</height>
  <uuid>{cb681ee4-2c2c-4020-a55c-534dafcf201f}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <label>Lf</label>
  <alignment>center</alignment>
  <font>Lucida Grande</font>
  <fontsize>10</fontsize>
  <precision>3</precision>
  <color>
   <r>230</r>
   <g>230</g>
   <b>230</b>
  </color>
  <bgcolor mode="nobackground">
   <r>255</r>
   <g>255</g>
   <b>255</b>
  </bgcolor>
  <bordermode>noborder</bordermode>
  <borderradius>1</borderradius>
  <borderwidth>1</borderwidth>
 </bsbObject>
 <bsbObject version="2" type="BSBLabel">
  <objectName/>
  <x>277</x>
  <y>162</y>
  <width>24</width>
  <height>24</height>
  <uuid>{d908f2b9-b3a2-4f23-8a92-6a563c47585b}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <label>Rf</label>
  <alignment>center</alignment>
  <font>Lucida Grande</font>
  <fontsize>10</fontsize>
  <precision>3</precision>
  <color>
   <r>230</r>
   <g>230</g>
   <b>230</b>
  </color>
  <bgcolor mode="nobackground">
   <r>255</r>
   <g>255</g>
   <b>255</b>
  </bgcolor>
  <bordermode>noborder</bordermode>
  <borderradius>1</borderradius>
  <borderwidth>1</borderwidth>
 </bsbObject>
 <bsbObject version="2" type="BSBLabel">
  <objectName/>
  <x>277</x>
  <y>377</y>
  <width>24</width>
  <height>24</height>
  <uuid>{15ef7e24-8a67-4eaa-b7fb-b61ac24d38bc}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <label>Rr</label>
  <alignment>center</alignment>
  <font>Lucida Grande</font>
  <fontsize>10</fontsize>
  <precision>3</precision>
  <color>
   <r>230</r>
   <g>230</g>
   <b>230</b>
  </color>
  <bgcolor mode="nobackground">
   <r>255</r>
   <g>255</g>
   <b>255</b>
  </bgcolor>
  <bordermode>noborder</bordermode>
  <borderradius>1</borderradius>
  <borderwidth>1</borderwidth>
 </bsbObject>
 <bsbObject version="2" type="BSBLabel">
  <objectName/>
  <x>61</x>
  <y>375</y>
  <width>24</width>
  <height>24</height>
  <uuid>{83f83f0c-4b7a-4648-9719-ead6af4392f6}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <label>Lr</label>
  <alignment>center</alignment>
  <font>Lucida Grande</font>
  <fontsize>10</fontsize>
  <precision>3</precision>
  <color>
   <r>230</r>
   <g>230</g>
   <b>230</b>
  </color>
  <bgcolor mode="nobackground">
   <r>255</r>
   <g>255</g>
   <b>255</b>
  </bgcolor>
  <bordermode>noborder</bordermode>
  <borderradius>1</borderradius>
  <borderwidth>1</borderwidth>
 </bsbObject>
 <bsbObject version="2" type="BSBDisplay">
  <objectName>yd2out</objectName>
  <x>8</x>
  <y>266</y>
  <width>82</width>
  <height>23</height>
  <uuid>{921b5ea0-0ed7-484a-9a99-13a46c070d0e}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <label>1.000</label>
  <alignment>center</alignment>
  <font>Lucida Grande</font>
  <fontsize>8</fontsize>
  <precision>3</precision>
  <color>
   <r>255</r>
   <g>255</g>
   <b>255</b>
  </color>
  <bgcolor mode="nobackground">
   <r>0</r>
   <g>0</g>
   <b>0</b>
  </bgcolor>
  <bordermode>noborder</bordermode>
  <borderradius>1</borderradius>
  <borderwidth>1</borderwidth>
 </bsbObject>
 <bsbObject version="2" type="BSBDisplay">
  <objectName>xd2out</objectName>
  <x>145</x>
  <y>380</y>
  <width>71</width>
  <height>25</height>
  <uuid>{96a2f98f-aa67-423c-b79a-2b8cc59b22ef}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <label>0.864</label>
  <alignment>center</alignment>
  <font>Lucida Grande</font>
  <fontsize>8</fontsize>
  <precision>3</precision>
  <color>
   <r>255</r>
   <g>255</g>
   <b>255</b>
  </color>
  <bgcolor mode="nobackground">
   <r>0</r>
   <g>0</g>
   <b>0</b>
  </bgcolor>
  <bordermode>noborder</bordermode>
  <borderradius>1</borderradius>
  <borderwidth>1</borderwidth>
 </bsbObject>
 <bsbObject version="2" type="BSBLabel">
  <objectName/>
  <x>168</x>
  <y>399</y>
  <width>24</width>
  <height>24</height>
  <uuid>{9b518914-fd6f-4c79-b661-a08198d1af48}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <label>x</label>
  <alignment>center</alignment>
  <font>Lucida Grande</font>
  <fontsize>10</fontsize>
  <precision>3</precision>
  <color>
   <r>230</r>
   <g>230</g>
   <b>230</b>
  </color>
  <bgcolor mode="nobackground">
   <r>255</r>
   <g>255</g>
   <b>255</b>
  </bgcolor>
  <bordermode>noborder</bordermode>
  <borderradius>1</borderradius>
  <borderwidth>1</borderwidth>
 </bsbObject>
 <bsbObject version="2" type="BSBLabel">
  <objectName/>
  <x>37</x>
  <y>241</y>
  <width>24</width>
  <height>24</height>
  <uuid>{a78ccaae-e7aa-43a0-afc2-13cad7590334}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <label>y</label>
  <alignment>center</alignment>
  <font>Lucida Grande</font>
  <fontsize>10</fontsize>
  <precision>3</precision>
  <color>
   <r>230</r>
   <g>230</g>
   <b>230</b>
  </color>
  <bgcolor mode="nobackground">
   <r>255</r>
   <g>255</g>
   <b>255</b>
  </bgcolor>
  <bordermode>noborder</bordermode>
  <borderradius>1</borderradius>
  <borderwidth>1</borderwidth>
 </bsbObject>
 <bsbObject version="2" type="BSBDropdown">
  <objectName>sig</objectName>
  <x>282</x>
  <y>86</y>
  <width>74</width>
  <height>23</height>
  <uuid>{385b0665-99ab-42b2-bc29-dc8d205f3ab2}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <bsbDropdownItemList>
   <bsbDropdownItem>
    <name>mic</name>
    <value>0</value>
    <stringvalue/>
   </bsbDropdownItem>
   <bsbDropdownItem>
    <name>wn</name>
    <value>1</value>
    <stringvalue/>
   </bsbDropdownItem>
   <bsbDropdownItem>
    <name>sine</name>
    <value>2</value>
    <stringvalue/>
   </bsbDropdownItem>
  </bsbDropdownItemList>
  <selectedIndex>2</selectedIndex>
  <randomizable group="0">false</randomizable>
 </bsbObject>
 <bsbObject version="2" type="BSBLabel">
  <objectName/>
  <x>285</x>
  <y>59</y>
  <width>68</width>
  <height>25</height>
  <uuid>{261091c2-3b40-4bb7-9458-39c8d22ea8d1}</uuid>
  <visible>true</visible>
  <midichan>0</midichan>
  <midicc>0</midicc>
  <label>signal</label>
  <alignment>center</alignment>
  <font>Arial</font>
  <fontsize>10</fontsize>
  <precision>3</precision>
  <color>
   <r>0</r>
   <g>0</g>
   <b>0</b>
  </color>
  <bgcolor mode="background">
   <r>255</r>
   <g>255</g>
   <b>255</b>
  </bgcolor>
  <bordermode>border</bordermode>
  <borderradius>1</borderradius>
  <borderwidth>1</borderwidth>
 </bsbObject>
</bsbPanel>
<bsbPresets>
</bsbPresets>
<MacOptions>
Version: 3
Render: Real
Ask: Yes
Functions: ioObject
Listing: Window
WindowBounds: 72 179 400 200
CurrentView: io
IOViewEdit: On
Options:
</MacOptions>

<MacGUI>
ioView background {23387, 23387, 23387}
ioButton {627, 131} {115, 45} event 1.000000 "" "Joystick" "/" i"matrix" 0 -1 1
ioText {432, 6} {511, 104} label 0.000000 0.00100 "" center "Arial" 14 {0, 0, 0} {52224, 52224, 52224} nobackground noborder CSOUND INSIDEÂ¬Enrico Francioni Â¬"Building Csound-based Systems for Realtime Chamber Music Performance"Â¬TUTORIAL #6-06: "eSpace" (by E.Francioni) - example of realtime spatialization of multichannel signals.
ioMeter {405, 183} {551, 551} {65280, 32768, 0} "x1in" 0.506352 "y1in" 0.382940 point 13 0 mouse
ioText {666, 766} {53, 31} label 0.000000 0.00100 "" center "Lucida Grande" 18 {65280, 65280, 65280} {65280, 65280, 65280} nobackground noborder x
ioText {347, 448} {53, 26} display -0.234120 0.00100 "y1out" center "Lucida Grande" 14 {65280, 65280, 65280} {65280, 65280, 65280} nobackground noborder -0.234
ioText {665, 739} {54, 27} display 0.012704 0.00100 "x1out" center "Lucida Grande" 14 {65280, 65280, 65280} {65280, 65280, 65280} nobackground noborder 0.013
ioText {347, 412} {53, 31} label 0.000000 0.00100 "" center "Lucida Grande" 18 {65280, 65280, 65280} {65280, 65280, 65280} nobackground noborder y
ioText {382, 161} {24, 24} label 0.000000 0.00100 "" center "Lucida Grande" 12 {58880, 58880, 58880} {65280, 65280, 65280} nobackground noborder Lf
ioText {954, 160} {24, 24} label 0.000000 0.00100 "" center "Lucida Grande" 12 {58880, 58880, 58880} {65280, 65280, 65280} nobackground noborder Rf
ioText {382, 732} {24, 24} label 0.000000 0.00100 "" center "Lucida Grande" 12 {58880, 58880, 58880} {65280, 65280, 65280} nobackground noborder Lr
ioText {955, 733} {24, 24} label 0.000000 0.00100 "" center "Lucida Grande" 12 {58880, 58880, 58880} {65280, 65280, 65280} nobackground noborder Rr
ioButton {1140, 489} {115, 45} event 1.000000 "" "Ping-pong" "/" i"matrix" 0 -1 5
ioMeter {1095, 536} {195, 195} {65280, 65280, 0} "pingx" 0.448582 "pongy" 0.147921 point 6 0 mouse
ioText {1020, 618} {82, 23} display -0.704159 0.00100 "yd5out" center "Lucida Grande" 8 {65280, 65280, 65280} {65280, 65280, 65280} nobackground noborder -0.704
ioText {1157, 732} {71, 25} display -0.102836 0.00100 "xd5out" center "Lucida Grande" 8 {65280, 65280, 65280} {65280, 65280, 65280} nobackground noborder -0.103
ioText {1075, 512} {24, 24} label 0.000000 0.00100 "" center "Lucida Grande" 10 {58880, 58880, 58880} {65280, 65280, 65280} nobackground noborder Lf
ioText {1289, 513} {24, 24} label 0.000000 0.00100 "" center "Lucida Grande" 10 {58880, 58880, 58880} {65280, 65280, 65280} nobackground noborder Rf
ioText {1289, 728} {24, 24} label 0.000000 0.00100 "" center "Lucida Grande" 10 {58880, 58880, 58880} {65280, 65280, 65280} nobackground noborder Rr
ioText {1073, 727} {24, 24} label 0.000000 0.00100 "" center "Lucida Grande" 10 {58880, 58880, 58880} {65280, 65280, 65280} nobackground noborder Lr
ioText {1180, 751} {24, 24} label 0.000000 0.00100 "" center "Lucida Grande" 10 {58880, 58880, 58880} {65280, 65280, 65280} nobackground noborder x
ioText {1049, 593} {24, 24} label 0.000000 0.00100 "" center "Lucida Grande" 10 {58880, 58880, 58880} {65280, 65280, 65280} nobackground noborder y
ioButton {1137, 139} {115, 45} event 1.000000 "" "Random" "/" i"matrix" 0 -1 4
ioMeter {1092, 186} {195, 195} {65280, 65280, 0} "x4out" 0.652317 "y4out" 0.896281 point 6 0 mouse
ioText {1017, 268} {82, 23} display 0.891632 0.00100 "yd4out" center "Lucida Grande" 8 {65280, 65280, 65280} {65280, 65280, 65280} nobackground noborder 0.892
ioText {1154, 382} {71, 25} display 0.342712 0.00100 "xd4out" center "Lucida Grande" 8 {65280, 65280, 65280} {65280, 65280, 65280} nobackground noborder 0.343
ioText {1072, 162} {24, 24} label 0.000000 0.00100 "" center "Lucida Grande" 10 {58880, 58880, 58880} {65280, 65280, 65280} nobackground noborder Lf
ioText {1286, 163} {24, 24} label 0.000000 0.00100 "" center "Lucida Grande" 10 {58880, 58880, 58880} {65280, 65280, 65280} nobackground noborder Rf
ioText {1286, 378} {24, 24} label 0.000000 0.00100 "" center "Lucida Grande" 10 {58880, 58880, 58880} {65280, 65280, 65280} nobackground noborder Rr
ioText {1070, 377} {24, 24} label 0.000000 0.00100 "" center "Lucida Grande" 10 {58880, 58880, 58880} {65280, 65280, 65280} nobackground noborder Lr
ioText {1177, 401} {24, 24} label 0.000000 0.00100 "" center "Lucida Grande" 10 {58880, 58880, 58880} {65280, 65280, 65280} nobackground noborder x
ioText {1046, 243} {24, 24} label 0.000000 0.00100 "" center "Lucida Grande" 10 {58880, 58880, 58880} {65280, 65280, 65280} nobackground noborder y
ioButton {131, 490} {115, 45} event 1.000000 "" "Circles" "/" i"matrix" 0 -1 3
ioMeter {86, 537} {195, 195} {65280, 65280, 0} "x3out" 0.418569 "y3out" 0.063079 point 6 0 mouse
ioText {66, 513} {24, 24} label 0.000000 0.00100 "" center "Lucida Grande" 10 {58880, 58880, 58880} {65280, 65280, 65280} nobackground noborder Lf
ioText {280, 514} {24, 24} label 0.000000 0.00100 "" center "Lucida Grande" 10 {58880, 58880, 58880} {65280, 65280, 65280} nobackground noborder Rf
ioText {280, 729} {24, 24} label 0.000000 0.00100 "" center "Lucida Grande" 10 {58880, 58880, 58880} {65280, 65280, 65280} nobackground noborder Rr
ioText {64, 728} {24, 24} label 0.000000 0.00100 "" center "Lucida Grande" 10 {58880, 58880, 58880} {65280, 65280, 65280} nobackground noborder Lr
ioText {8, 616} {82, 23} display -0.983072 0.00100 "yd3out" center "Lucida Grande" 8 {65280, 65280, 65280} {65280, 65280, 65280} nobackground noborder -0.983
ioText {144, 730} {71, 25} display -0.183221 0.00100 "xd3out" center "Lucida Grande" 8 {65280, 65280, 65280} {65280, 65280, 65280} nobackground noborder -0.183
ioText {167, 749} {24, 24} label 0.000000 0.00100 "" center "Lucida Grande" 10 {58880, 58880, 58880} {65280, 65280, 65280} nobackground noborder x
ioText {36, 591} {24, 24} label 0.000000 0.00100 "" center "Lucida Grande" 10 {58880, 58880, 58880} {65280, 65280, 65280} nobackground noborder y
ioButton {128, 137} {115, 45} event 1.000000 "" "Lines" "/" i"matrix" 0 -1 2
ioMeter {83, 184} {195, 195} {65280, 65280, 0} "x2out" 0.884054 "y2out" 0.944444 point 6 0 mouse
ioText {63, 160} {24, 24} label 0.000000 0.00100 "" center "Lucida Grande" 10 {58880, 58880, 58880} {65280, 65280, 65280} nobackground noborder Lf
ioText {277, 162} {24, 24} label 0.000000 0.00100 "" center "Lucida Grande" 10 {58880, 58880, 58880} {65280, 65280, 65280} nobackground noborder Rf
ioText {277, 377} {24, 24} label 0.000000 0.00100 "" center "Lucida Grande" 10 {58880, 58880, 58880} {65280, 65280, 65280} nobackground noborder Rr
ioText {61, 375} {24, 24} label 0.000000 0.00100 "" center "Lucida Grande" 10 {58880, 58880, 58880} {65280, 65280, 65280} nobackground noborder Lr
ioText {8, 266} {82, 23} display 1.000000 0.00100 "yd2out" center "Lucida Grande" 8 {65280, 65280, 65280} {65280, 65280, 65280} nobackground noborder 1.000
ioText {145, 380} {71, 25} display 0.864121 0.00100 "xd2out" center "Lucida Grande" 8 {65280, 65280, 65280} {65280, 65280, 65280} nobackground noborder 0.864
ioText {168, 399} {24, 24} label 0.000000 0.00100 "" center "Lucida Grande" 10 {58880, 58880, 58880} {65280, 65280, 65280} nobackground noborder x
ioText {37, 241} {24, 24} label 0.000000 0.00100 "" center "Lucida Grande" 10 {58880, 58880, 58880} {65280, 65280, 65280} nobackground noborder y
ioMenu {282, 86} {74, 23} 2 303 "mic,wn,sine" sig
ioText {285, 59} {68, 25} label 0.000000 0.00100 "" center "Arial" 10 {0, 0, 0} {65280, 65280, 65280} nobackground noborder signal
</MacGUI>
